/*
    Copyright 2016-2022 melonDS team

    This file is part of melonDS.

    melonDS is free software: you can redistribute it and/or modify it under
    the terms of the GNU General Public License as published by the Free
    Software Foundation, either version 3 of the License, or (at your option)
    any later version.

    melonDS is distributed in the hope that it will be useful, but WITHOUT ANY
    WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
    FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with melonDS. If not, see http://www.gnu.org/licenses/.
*/

INSTRFUNC_PROTO(InstrTable[65536]) =
{
    // 0000 0000 0000 0000
    OP_GLUE_0000, OP_GLUE_0001, OP_GLUE_0002, OP_GLUE_0002,
    OP_GLUE_0004, OP_GLUE_0004, OP_GLUE_0006, OP_GLUE_0006,
    OP_GLUE_0008, OP_GLUE_0008, OP_GLUE_0008, OP_GLUE_0008,
    OP_GLUE_0008, OP_GLUE_0008, OP_GLUE_0008, OP_GLUE_0008,

    // 0000 0000 0001 0000
    OP_GLUE_0010, OP_GLUE_0010, OP_GLUE_0010, OP_GLUE_0010,
    OP_GLUE_0010, OP_GLUE_0010, OP_GLUE_0010, OP_GLUE_0010,
    OP_GLUE_0010, OP_GLUE_0010, OP_GLUE_0010, OP_GLUE_0010,
    OP_GLUE_0010, OP_GLUE_0010, OP_GLUE_0010, OP_GLUE_0010,

    // 0000 0000 0010 0000
    OP_GLUE_0020, OP_UNDEFINED, OP_UNDEFINED, OP_GLUE_0023,
    OP_GLUE_0024, OP_GLUE_0024, OP_GLUE_0006, OP_GLUE_0006,
    OP_GLUE_0028, OP_GLUE_0028, OP_GLUE_0028, OP_GLUE_0028,
    OP_GLUE_0028, OP_GLUE_0028, OP_GLUE_0028, OP_GLUE_0028,

    // 0000 0000 0011 0000
    OP_GLUE_0030, OP_GLUE_0030, OP_GLUE_0030, OP_GLUE_0030,
    OP_GLUE_0030, OP_GLUE_0030, OP_GLUE_0030, OP_GLUE_0030,
    OP_GLUE_0038, OP_GLUE_0038, OP_GLUE_0038, OP_GLUE_0038,
    OP_GLUE_0038, OP_GLUE_0038, OP_GLUE_0038, OP_GLUE_0038,

    // 0000 0000 0100 0000
    OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040,
    OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040,
    OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040,
    OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040,

    // 0000 0000 0101 0000
    OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040,
    OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040,
    OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040,
    OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040,

    // 0000 0000 0110 0000
    OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040,
    OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040,
    OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040,
    OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040,

    // 0000 0000 0111 0000
    OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040,
    OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040,
    OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040,
    OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040, OP_GLUE_0040,

    // 0000 0000 1000 0000
    OP_GLUE_0080, OP_GLUE_0080, OP_GLUE_0080, OP_GLUE_0080,
    OP_GLUE_0080, OP_GLUE_0080, OP_GLUE_0080, OP_GLUE_0080,
    OP_GLUE_0080, OP_GLUE_0080, OP_GLUE_0080, OP_GLUE_0080,
    OP_GLUE_0080, OP_GLUE_0080, OP_GLUE_0080, OP_GLUE_0080,

    // 0000 0000 1001 0000
    OP_GLUE_0080, OP_GLUE_0080, OP_GLUE_0080, OP_GLUE_0080,
    OP_GLUE_0080, OP_GLUE_0080, OP_GLUE_0080, OP_GLUE_0080,
    OP_GLUE_0080, OP_GLUE_0080, OP_GLUE_0080, OP_GLUE_0080,
    OP_GLUE_0080, OP_GLUE_0080, OP_GLUE_0080, OP_GLUE_0080,

    // 0000 0000 1010 0000
    OP_GLUE_00A0, OP_GLUE_00A0, OP_GLUE_00A0, OP_GLUE_00A0,
    OP_GLUE_00A0, OP_GLUE_00A0, OP_GLUE_00A0, OP_GLUE_00A0,
    OP_GLUE_00A0, OP_GLUE_00A0, OP_GLUE_00A0, OP_GLUE_00A0,
    OP_GLUE_00A0, OP_GLUE_00A0, OP_GLUE_00A0, OP_GLUE_00A0,

    // 0000 0000 1011 0000
    OP_GLUE_00A0, OP_GLUE_00A0, OP_GLUE_00A0, OP_GLUE_00A0,
    OP_GLUE_00A0, OP_GLUE_00A0, OP_GLUE_00A0, OP_GLUE_00A0,
    OP_GLUE_00A0, OP_GLUE_00A0, OP_GLUE_00A0, OP_GLUE_00A0,
    OP_GLUE_00A0, OP_GLUE_00A0, OP_GLUE_00A0, OP_GLUE_00A0,

    // 0000 0000 1100 0000
    OP_GLUE_00C0, OP_GLUE_00C1, OP_GLUE_00C0, OP_GLUE_00C1,
    OP_GLUE_00C0, OP_GLUE_00C1, OP_GLUE_00C0, OP_GLUE_00C1,
    OP_GLUE_00C0, OP_GLUE_00C1, OP_GLUE_00C0, OP_GLUE_00C1,
    OP_GLUE_00C0, OP_GLUE_00C1, OP_GLUE_00C0, OP_GLUE_00C1,

    // 0000 0000 1101 0000
    OP_GLUE_00C0, OP_GLUE_00C1, OP_GLUE_00C0, OP_GLUE_00C1,
    OP_GLUE_00C0, OP_GLUE_00C1, OP_GLUE_00C0, OP_GLUE_00C1,
    OP_GLUE_00C0, OP_GLUE_00C1, OP_GLUE_00C0, OP_GLUE_00C1,
    OP_GLUE_00C0, OP_GLUE_00C1, OP_GLUE_00C0, OP_GLUE_00C1,

    // 0000 0000 1110 0000
    OP_GLUE_00C0, OP_GLUE_00C1, OP_GLUE_00C0, OP_GLUE_00C1,
    OP_GLUE_00C0, OP_GLUE_00C1, OP_GLUE_00C0, OP_GLUE_00C1,
    OP_GLUE_00C0, OP_GLUE_00C1, OP_GLUE_00C0, OP_GLUE_00C1,
    OP_GLUE_00C0, OP_GLUE_00C1, OP_GLUE_00C0, OP_GLUE_00C1,

    // 0000 0000 1111 0000
    OP_GLUE_00C0, OP_GLUE_00C1, OP_GLUE_00C0, OP_GLUE_00C1,
    OP_GLUE_00C0, OP_GLUE_00C1, OP_GLUE_00C0, OP_GLUE_00C1,
    OP_GLUE_00C0, OP_GLUE_00C1, OP_GLUE_00C0, OP_GLUE_00C1,
    OP_GLUE_00C0, OP_GLUE_00C1, OP_GLUE_00C0, OP_GLUE_00C1,

    // 0000 0001 0000 0000
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,

    // 0000 0001 0001 0000
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,

    // 0000 0001 0010 0000
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,

    // 0000 0001 0011 0000
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,

    // 0000 0001 0100 0000
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,

    // 0000 0001 0101 0000
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,

    // 0000 0001 0110 0000
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,

    // 0000 0001 0111 0000
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,
    OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100, OP_GLUE_0100,

    // 0000 0001 1000 0000
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,

    // 0000 0001 1001 0000
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,

    // 0000 0001 1010 0000
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,

    // 0000 0001 1011 0000
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,

    // 0000 0001 1100 0000
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,

    // 0000 0001 1101 0000
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,

    // 0000 0001 1110 0000
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,

    // 0000 0001 1111 0000
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,
    OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180, OP_GLUE_0180,

    // 0000 0010 0000 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0010 0001 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0010 0010 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0010 0011 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0010 0100 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0010 0101 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0010 0110 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0010 0111 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0010 1000 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0010 1001 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0010 1010 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0010 1011 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0010 1100 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0010 1101 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0010 1110 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0010 1111 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0011 0000 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0011 0001 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0011 0010 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0011 0011 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0011 0100 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0011 0101 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0011 0110 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0011 0111 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0011 1000 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0011 1001 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0011 1010 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0011 1011 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0011 1100 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0011 1101 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0011 1110 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0011 1111 0000
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,
    OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200, OP_GLUE_0200,

    // 0000 0100 0000 0000
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,

    // 0000 0100 0001 0000
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,

    // 0000 0100 0010 0000
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,

    // 0000 0100 0011 0000
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,

    // 0000 0100 0100 0000
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,

    // 0000 0100 0101 0000
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,

    // 0000 0100 0110 0000
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,

    // 0000 0100 0111 0000
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,

    // 0000 0100 1000 0000
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,

    // 0000 0100 1001 0000
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,

    // 0000 0100 1010 0000
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,

    // 0000 0100 1011 0000
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,

    // 0000 0100 1100 0000
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,

    // 0000 0100 1101 0000
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,

    // 0000 0100 1110 0000
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,

    // 0000 0100 1111 0000
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,
    OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400, OP_GLUE_0400,

    // 0000 0101 0000 0000
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,

    // 0000 0101 0001 0000
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,

    // 0000 0101 0010 0000
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,

    // 0000 0101 0011 0000
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,

    // 0000 0101 0100 0000
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,

    // 0000 0101 0101 0000
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,

    // 0000 0101 0110 0000
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,

    // 0000 0101 0111 0000
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,

    // 0000 0101 1000 0000
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,

    // 0000 0101 1001 0000
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,

    // 0000 0101 1010 0000
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,

    // 0000 0101 1011 0000
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,

    // 0000 0101 1100 0000
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,

    // 0000 0101 1101 0000
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,

    // 0000 0101 1110 0000
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,

    // 0000 0101 1111 0000
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,
    OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500, OP_GLUE_0500,

    // 0000 0110 0000 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0110 0001 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0110 0010 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0110 0011 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0110 0100 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0110 0101 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0110 0110 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0110 0111 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0110 1000 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0110 1001 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0110 1010 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0110 1011 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0110 1100 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0110 1101 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0110 1110 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0110 1111 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0111 0000 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0111 0001 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0111 0010 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0111 0011 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0111 0100 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0111 0101 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0111 0110 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0111 0111 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0111 1000 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0111 1001 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0111 1010 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0111 1011 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0111 1100 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0111 1101 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0111 1110 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 0111 1111 0000
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,
    OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600, OP_GLUE_0600,

    // 0000 1000 0000 0000
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,

    // 0000 1000 0001 0000
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,

    // 0000 1000 0010 0000
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,

    // 0000 1000 0011 0000
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,

    // 0000 1000 0100 0000
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,

    // 0000 1000 0101 0000
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,

    // 0000 1000 0110 0000
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,

    // 0000 1000 0111 0000
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,

    // 0000 1000 1000 0000
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,

    // 0000 1000 1001 0000
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,

    // 0000 1000 1010 0000
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,

    // 0000 1000 1011 0000
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,

    // 0000 1000 1100 0000
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,

    // 0000 1000 1101 0000
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,

    // 0000 1000 1110 0000
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,

    // 0000 1000 1111 0000
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,
    OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800, OP_GLUE_0800,

    // 0000 1001 0000 0000
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,

    // 0000 1001 0001 0000
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,

    // 0000 1001 0010 0000
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,

    // 0000 1001 0011 0000
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,

    // 0000 1001 0100 0000
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,

    // 0000 1001 0101 0000
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,

    // 0000 1001 0110 0000
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,

    // 0000 1001 0111 0000
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,

    // 0000 1001 1000 0000
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,

    // 0000 1001 1001 0000
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,

    // 0000 1001 1010 0000
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,

    // 0000 1001 1011 0000
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,

    // 0000 1001 1100 0000
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,

    // 0000 1001 1101 0000
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,

    // 0000 1001 1110 0000
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,

    // 0000 1001 1111 0000
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,
    OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900, OP_GLUE_0900,

    // 0000 1010 0000 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1010 0001 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1010 0010 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1010 0011 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1010 0100 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1010 0101 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1010 0110 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1010 0111 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1010 1000 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1010 1001 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1010 1010 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1010 1011 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1010 1100 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1010 1101 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1010 1110 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1010 1111 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1011 0000 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1011 0001 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1011 0010 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1011 0011 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1011 0100 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1011 0101 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1011 0110 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1011 0111 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1011 1000 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1011 1001 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1011 1010 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1011 1011 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1011 1100 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1011 1101 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1011 1110 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1011 1111 0000
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,
    OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00, OP_GLUE_0A00,

    // 0000 1100 0000 0000
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,

    // 0000 1100 0001 0000
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,

    // 0000 1100 0010 0000
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,

    // 0000 1100 0011 0000
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,

    // 0000 1100 0100 0000
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,

    // 0000 1100 0101 0000
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,

    // 0000 1100 0110 0000
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,

    // 0000 1100 0111 0000
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,

    // 0000 1100 1000 0000
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,

    // 0000 1100 1001 0000
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,

    // 0000 1100 1010 0000
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,

    // 0000 1100 1011 0000
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,

    // 0000 1100 1100 0000
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,

    // 0000 1100 1101 0000
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,

    // 0000 1100 1110 0000
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,

    // 0000 1100 1111 0000
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,
    OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00, OP_GLUE_0C00,

    // 0000 1101 0000 0000
    OP_GLUE_0D00, OP_GLUE_0D00, OP_GLUE_0D00, OP_GLUE_0D00,
    OP_GLUE_0D00, OP_GLUE_0D00, OP_GLUE_0D00, OP_GLUE_0D00,
    OP_GLUE_0D00, OP_GLUE_0D00, OP_GLUE_0D00, OP_GLUE_0D00,
    OP_GLUE_0D00, OP_GLUE_0D00, OP_GLUE_0D00, OP_GLUE_0D00,

    // 0000 1101 0001 0000
    OP_GLUE_0D00, OP_GLUE_0D00, OP_GLUE_0D00, OP_GLUE_0D00,
    OP_GLUE_0D00, OP_GLUE_0D00, OP_GLUE_0D00, OP_GLUE_0D00,
    OP_GLUE_0D00, OP_GLUE_0D00, OP_GLUE_0D00, OP_GLUE_0D00,
    OP_GLUE_0D00, OP_GLUE_0D00, OP_GLUE_0D00, OP_GLUE_0D00,

    // 0000 1101 0010 0000
    OP_GLUE_0D20, OP_GLUE_0D20, OP_GLUE_0D20, OP_GLUE_0D20,
    OP_GLUE_0D20, OP_GLUE_0D20, OP_GLUE_0D20, OP_GLUE_0D20,
    OP_GLUE_0D20, OP_GLUE_0D20, OP_GLUE_0D20, OP_GLUE_0D20,
    OP_GLUE_0D20, OP_GLUE_0D20, OP_GLUE_0D20, OP_GLUE_0D20,

    // 0000 1101 0011 0000
    OP_GLUE_0D30, OP_GLUE_0D30, OP_GLUE_0D30, OP_GLUE_0D30,
    OP_GLUE_0D30, OP_GLUE_0D30, OP_GLUE_0D30, OP_GLUE_0D30,
    OP_GLUE_0D30, OP_GLUE_0D30, OP_GLUE_0D30, OP_GLUE_0D30,
    OP_GLUE_0D30, OP_GLUE_0D30, OP_GLUE_0D30, OP_GLUE_0D30,

    // 0000 1101 0100 0000
    OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40,
    OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40,
    OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40,
    OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40,

    // 0000 1101 0101 0000
    OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40,
    OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40,
    OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40,
    OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40,

    // 0000 1101 0110 0000
    OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40,
    OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40,
    OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40,
    OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40,

    // 0000 1101 0111 0000
    OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40,
    OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40,
    OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40,
    OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40, OP_GLUE_0D40,

    // 0000 1101 1000 0000
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,

    // 0000 1101 1001 0000
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,

    // 0000 1101 1010 0000
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,

    // 0000 1101 1011 0000
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,

    // 0000 1101 1100 0000
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,

    // 0000 1101 1101 0000
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,

    // 0000 1101 1110 0000
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,

    // 0000 1101 1111 0000
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,
    OP_GLUE_0D80, OP_GLUE_0D81, OP_GLUE_0D80, OP_GLUE_0D81,

    // 0000 1110 0000 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1110 0001 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1110 0010 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1110 0011 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1110 0100 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1110 0101 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1110 0110 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1110 0111 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1110 1000 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1110 1001 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1110 1010 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1110 1011 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1110 1100 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1110 1101 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1110 1110 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1110 1111 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1111 0000 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1111 0001 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1111 0010 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1111 0011 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1111 0100 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1111 0101 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1111 0110 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1111 0111 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1111 1000 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1111 1001 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1111 1010 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1111 1011 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1111 1100 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1111 1101 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1111 1110 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0000 1111 1111 0000
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,
    OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00, OP_GLUE_0E00,

    // 0001 0000 0000 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0000 0001 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0000 0010 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0000 0011 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0000 0100 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0000 0101 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0000 0110 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0000 0111 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0000 1000 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0000 1001 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0000 1010 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0000 1011 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0000 1100 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0000 1101 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0000 1110 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0000 1111 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0001 0000 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0001 0001 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0001 0010 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0001 0011 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0001 0100 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0001 0101 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0001 0110 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0001 0111 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0001 1000 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0001 1001 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0001 1010 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0001 1011 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0001 1100 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0001 1101 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0001 1110 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0001 1111 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0010 0000 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0010 0001 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0010 0010 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0010 0011 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0010 0100 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0010 0101 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0010 0110 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0010 0111 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0010 1000 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0010 1001 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0010 1010 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0010 1011 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0010 1100 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0010 1101 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0010 1110 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0010 1111 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0011 0000 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0011 0001 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0011 0010 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0011 0011 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0011 0100 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0011 0101 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0011 0110 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0011 0111 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0011 1000 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0011 1001 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0011 1010 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0011 1011 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0011 1100 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0011 1101 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0011 1110 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0011 1111 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0100 0000 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0100 0001 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0100 0010 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0100 0011 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0100 0100 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0100 0101 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0100 0110 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0100 0111 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0100 1000 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0100 1001 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0100 1010 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0100 1011 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0100 1100 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0100 1101 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0100 1110 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0100 1111 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0101 0000 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0101 0001 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0101 0010 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0101 0011 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0101 0100 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0101 0101 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0101 0110 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0101 0111 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0101 1000 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0101 1001 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0101 1010 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0101 1011 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0101 1100 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0101 1101 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0101 1110 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0101 1111 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0110 0000 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0110 0001 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0110 0010 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0110 0011 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0110 0100 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0110 0101 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0110 0110 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0110 0111 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0110 1000 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0110 1001 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0110 1010 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0110 1011 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0110 1100 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0110 1101 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0110 1110 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0110 1111 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0111 0000 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0111 0001 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0111 0010 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0111 0011 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0111 0100 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0111 0101 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0111 0110 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0111 0111 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0111 1000 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0111 1001 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0111 1010 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0111 1011 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0111 1100 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0111 1101 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0111 1110 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 0111 1111 0000
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,
    OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000, OP_GLUE_1000,

    // 0001 1000 0000 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1000 0001 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1000 0010 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1000 0011 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1000 0100 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1000 0101 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1000 0110 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1000 0111 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1000 1000 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1000 1001 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1000 1010 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1000 1011 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1000 1100 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1000 1101 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1000 1110 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1000 1111 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1001 0000 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1001 0001 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1001 0010 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1001 0011 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1001 0100 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1001 0101 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1001 0110 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1001 0111 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1001 1000 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1001 1001 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1001 1010 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1001 1011 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1001 1100 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1001 1101 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1001 1110 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1001 1111 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1010 0000 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1010 0001 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1010 0010 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1010 0011 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1010 0100 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1010 0101 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1010 0110 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1010 0111 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1010 1000 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1010 1001 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1010 1010 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1010 1011 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1010 1100 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1010 1101 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1010 1110 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1010 1111 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1011 0000 0000
    OP_GLUE_1B00, OP_GLUE_1B00, OP_GLUE_1B00, OP_GLUE_1B00,
    OP_GLUE_1B00, OP_GLUE_1B00, OP_GLUE_1B00, OP_GLUE_1B00,
    OP_GLUE_1B00, OP_GLUE_1B00, OP_GLUE_1B00, OP_GLUE_1B00,
    OP_GLUE_1B00, OP_GLUE_1B00, OP_GLUE_1B00, OP_GLUE_1B00,

    // 0001 1011 0001 0000
    OP_GLUE_1B00, OP_GLUE_1B00, OP_GLUE_1B00, OP_GLUE_1B00,
    OP_GLUE_1B00, OP_GLUE_1B00, OP_GLUE_1B00, OP_GLUE_1B00,
    OP_GLUE_1B00, OP_GLUE_1B00, OP_GLUE_1B00, OP_GLUE_1B00,
    OP_GLUE_1B00, OP_GLUE_1B00, OP_GLUE_1B00, OP_GLUE_1B00,

    // 0001 1011 0010 0000
    OP_GLUE_1B20, OP_GLUE_1B20, OP_GLUE_1B20, OP_GLUE_1B20,
    OP_GLUE_1B20, OP_GLUE_1B20, OP_GLUE_1B20, OP_GLUE_1B20,
    OP_GLUE_1B20, OP_GLUE_1B20, OP_GLUE_1B20, OP_GLUE_1B20,
    OP_GLUE_1B20, OP_GLUE_1B20, OP_GLUE_1B20, OP_GLUE_1B20,

    // 0001 1011 0011 0000
    OP_GLUE_1B20, OP_GLUE_1B20, OP_GLUE_1B20, OP_GLUE_1B20,
    OP_GLUE_1B20, OP_GLUE_1B20, OP_GLUE_1B20, OP_GLUE_1B20,
    OP_GLUE_1B20, OP_GLUE_1B20, OP_GLUE_1B20, OP_GLUE_1B20,
    OP_GLUE_1B20, OP_GLUE_1B20, OP_GLUE_1B20, OP_GLUE_1B20,

    // 0001 1011 0100 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1011 0101 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1011 0110 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1011 0111 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1011 1000 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1011 1001 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1011 1010 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1011 1011 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1011 1100 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1011 1101 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1011 1110 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1011 1111 0000
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,
    OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800, OP_GLUE_1800,

    // 0001 1100 0000 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1100 0001 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1100 0010 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1100 0011 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1100 0100 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1100 0101 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1100 0110 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1100 0111 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1100 1000 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1100 1001 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1100 1010 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1100 1011 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1100 1100 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1100 1101 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1100 1110 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1100 1111 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1101 0000 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1101 0001 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1101 0010 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1101 0011 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1101 0100 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1101 0101 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1101 0110 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1101 0111 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1101 1000 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1101 1001 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1101 1010 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1101 1011 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1101 1100 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1101 1101 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1101 1110 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1101 1111 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1110 0000 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1110 0001 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1110 0010 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1110 0011 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1110 0100 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1110 0101 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1110 0110 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1110 0111 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1110 1000 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1110 1001 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1110 1010 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1110 1011 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1110 1100 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1110 1101 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1110 1110 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1110 1111 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1111 0000 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1111 0001 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1111 0010 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1111 0011 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1111 0100 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1111 0101 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1111 0110 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1111 0111 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1111 1000 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1111 1001 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1111 1010 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1111 1011 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1111 1100 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1111 1101 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1111 1110 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0001 1111 1111 0000
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,
    OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00, OP_GLUE_1C00,

    // 0010 0000 0000 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0000 0001 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0000 0010 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0000 0011 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0000 0100 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0000 0101 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0000 0110 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0000 0111 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0000 1000 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0000 1001 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0000 1010 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0000 1011 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0000 1100 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0000 1101 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0000 1110 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0000 1111 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0001 0000 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0010 0001 0001 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0010 0001 0010 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0010 0001 0011 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0010 0001 0100 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0010 0001 0101 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0010 0001 0110 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0010 0001 0111 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0010 0001 1000 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0010 0001 1001 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0010 0001 1010 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0010 0001 1011 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0010 0001 1100 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0010 0001 1101 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0010 0001 1110 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0010 0001 1111 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0010 0010 0000 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0010 0001 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0010 0010 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0010 0011 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0010 0100 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0010 0101 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0010 0110 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0010 0111 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0010 1000 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0010 1001 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0010 1010 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0010 1011 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0010 1100 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0010 1101 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0010 1110 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0010 1111 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0011 0000 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0011 0001 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0011 0010 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0011 0011 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0011 0100 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0011 0101 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0011 0110 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0011 0111 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0011 1000 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0011 1001 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0011 1010 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0011 1011 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0011 1100 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0011 1101 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0011 1110 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0011 1111 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0100 0000 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0100 0001 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0100 0010 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0100 0011 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0100 0100 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0100 0101 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0100 0110 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0100 0111 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0100 1000 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0100 1001 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0100 1010 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0100 1011 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0100 1100 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0100 1101 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0100 1110 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0100 1111 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0101 0000 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0010 0101 0001 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0010 0101 0010 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0010 0101 0011 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0010 0101 0100 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0010 0101 0101 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0010 0101 0110 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0010 0101 0111 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0010 0101 1000 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0010 0101 1001 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0010 0101 1010 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0010 0101 1011 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0010 0101 1100 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0010 0101 1101 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0010 0101 1110 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0010 0101 1111 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0010 0110 0000 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0110 0001 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0110 0010 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0110 0011 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0110 0100 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0110 0101 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0110 0110 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0110 0111 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0110 1000 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0110 1001 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0110 1010 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0110 1011 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0110 1100 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0110 1101 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0110 1110 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0110 1111 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 0111 0000 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0111 0001 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0111 0010 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0111 0011 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0111 0100 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0111 0101 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0111 0110 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0111 0111 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0111 1000 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0111 1001 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0111 1010 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0111 1011 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0111 1100 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0111 1101 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0111 1110 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 0111 1111 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1000 0000 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1000 0001 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1000 0010 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1000 0011 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1000 0100 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1000 0101 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1000 0110 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1000 0111 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1000 1000 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1000 1001 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1000 1010 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1000 1011 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1000 1100 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1000 1101 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1000 1110 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1000 1111 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1001 0000 0000
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,

    // 0010 1001 0001 0000
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,

    // 0010 1001 0010 0000
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,

    // 0010 1001 0011 0000
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,

    // 0010 1001 0100 0000
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,

    // 0010 1001 0101 0000
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,

    // 0010 1001 0110 0000
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,

    // 0010 1001 0111 0000
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,

    // 0010 1001 1000 0000
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,

    // 0010 1001 1001 0000
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,

    // 0010 1001 1010 0000
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,

    // 0010 1001 1011 0000
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,

    // 0010 1001 1100 0000
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,

    // 0010 1001 1101 0000
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,

    // 0010 1001 1110 0000
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,

    // 0010 1001 1111 0000
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,
    OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900, OP_GLUE_2900,

    // 0010 1010 0000 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1010 0001 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1010 0010 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1010 0011 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1010 0100 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1010 0101 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1010 0110 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1010 0111 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1010 1000 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1010 1001 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1010 1010 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1010 1011 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1010 1100 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1010 1101 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1010 1110 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1010 1111 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1011 0000 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1011 0001 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1011 0010 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1011 0011 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1011 0100 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1011 0101 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1011 0110 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1011 0111 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1011 1000 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1011 1001 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1011 1010 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1011 1011 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1011 1100 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1011 1101 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1011 1110 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1011 1111 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1100 0000 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1100 0001 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1100 0010 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1100 0011 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1100 0100 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1100 0101 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1100 0110 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1100 0111 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1100 1000 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1100 1001 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1100 1010 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1100 1011 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1100 1100 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1100 1101 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1100 1110 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1100 1111 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1101 0000 0000
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,

    // 0010 1101 0001 0000
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,

    // 0010 1101 0010 0000
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,

    // 0010 1101 0011 0000
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,

    // 0010 1101 0100 0000
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,

    // 0010 1101 0101 0000
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,

    // 0010 1101 0110 0000
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,

    // 0010 1101 0111 0000
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,

    // 0010 1101 1000 0000
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,

    // 0010 1101 1001 0000
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,

    // 0010 1101 1010 0000
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,

    // 0010 1101 1011 0000
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,

    // 0010 1101 1100 0000
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,

    // 0010 1101 1101 0000
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,

    // 0010 1101 1110 0000
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,

    // 0010 1101 1111 0000
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,
    OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00, OP_GLUE_2D00,

    // 0010 1110 0000 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1110 0001 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1110 0010 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1110 0011 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1110 0100 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1110 0101 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1110 0110 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1110 0111 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1110 1000 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1110 1001 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1110 1010 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1110 1011 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1110 1100 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1110 1101 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1110 1110 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1110 1111 0000
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,
    OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000, OP_GLUE_2000,

    // 0010 1111 0000 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1111 0001 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1111 0010 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1111 0011 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1111 0100 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1111 0101 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1111 0110 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1111 0111 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1111 1000 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1111 1001 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1111 1010 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1111 1011 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1111 1100 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1111 1101 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1111 1110 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0010 1111 1111 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0000 0000 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0000 0001 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0000 0010 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0000 0011 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0000 0100 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0000 0101 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0000 0110 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0000 0111 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0000 1000 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0000 1001 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0000 1010 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0000 1011 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0000 1100 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0000 1101 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0000 1110 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0000 1111 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0001 0000 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0011 0001 0001 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0011 0001 0010 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0011 0001 0011 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0011 0001 0100 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0011 0001 0101 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0011 0001 0110 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0011 0001 0111 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0011 0001 1000 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0011 0001 1001 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0011 0001 1010 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0011 0001 1011 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0011 0001 1100 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0011 0001 1101 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0011 0001 1110 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0011 0001 1111 0000
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,
    OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100, OP_GLUE_2100,

    // 0011 0010 0000 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0010 0001 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0010 0010 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0010 0011 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0010 0100 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0010 0101 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0010 0110 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0010 0111 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0010 1000 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0010 1001 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0010 1010 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0010 1011 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0010 1100 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0010 1101 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0010 1110 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0010 1111 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0011 0000 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0011 0001 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0011 0010 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0011 0011 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0011 0100 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0011 0101 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0011 0110 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0011 0111 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0011 1000 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0011 1001 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0011 1010 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0011 1011 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0011 1100 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0011 1101 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0011 1110 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0011 1111 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0100 0000 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0100 0001 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0100 0010 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0100 0011 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0100 0100 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0100 0101 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0100 0110 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0100 0111 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0100 1000 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0100 1001 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0100 1010 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0100 1011 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0100 1100 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0100 1101 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0100 1110 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0100 1111 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0101 0000 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0011 0101 0001 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0011 0101 0010 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0011 0101 0011 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0011 0101 0100 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0011 0101 0101 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0011 0101 0110 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0011 0101 0111 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0011 0101 1000 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0011 0101 1001 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0011 0101 1010 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0011 0101 1011 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0011 0101 1100 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0011 0101 1101 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0011 0101 1110 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0011 0101 1111 0000
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,
    OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500, OP_GLUE_2500,

    // 0011 0110 0000 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0110 0001 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0110 0010 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0110 0011 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0110 0100 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0110 0101 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0110 0110 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0110 0111 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0110 1000 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0110 1001 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0110 1010 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0110 1011 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0110 1100 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0110 1101 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0110 1110 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0110 1111 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 0111 0000 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0111 0001 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0111 0010 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0111 0011 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0111 0100 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0111 0101 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0111 0110 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0111 0111 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0111 1000 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0111 1001 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0111 1010 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0111 1011 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0111 1100 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0111 1101 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0111 1110 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 0111 1111 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1000 0000 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1000 0001 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1000 0010 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1000 0011 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1000 0100 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1000 0101 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1000 0110 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1000 0111 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1000 1000 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1000 1001 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1000 1010 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1000 1011 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1000 1100 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1000 1101 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1000 1110 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1000 1111 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1001 0000 0000
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,

    // 0011 1001 0001 0000
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,

    // 0011 1001 0010 0000
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,

    // 0011 1001 0011 0000
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,

    // 0011 1001 0100 0000
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,

    // 0011 1001 0101 0000
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,

    // 0011 1001 0110 0000
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,

    // 0011 1001 0111 0000
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,

    // 0011 1001 1000 0000
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,

    // 0011 1001 1001 0000
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,

    // 0011 1001 1010 0000
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,

    // 0011 1001 1011 0000
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,

    // 0011 1001 1100 0000
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,

    // 0011 1001 1101 0000
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,

    // 0011 1001 1110 0000
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,

    // 0011 1001 1111 0000
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,
    OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900, OP_GLUE_3900,

    // 0011 1010 0000 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1010 0001 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1010 0010 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1010 0011 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1010 0100 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1010 0101 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1010 0110 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1010 0111 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1010 1000 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1010 1001 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1010 1010 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1010 1011 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1010 1100 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1010 1101 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1010 1110 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1010 1111 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1011 0000 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1011 0001 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1011 0010 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1011 0011 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1011 0100 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1011 0101 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1011 0110 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1011 0111 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1011 1000 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1011 1001 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1011 1010 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1011 1011 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1011 1100 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1011 1101 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1011 1110 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1011 1111 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1100 0000 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1100 0001 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1100 0010 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1100 0011 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1100 0100 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1100 0101 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1100 0110 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1100 0111 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1100 1000 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1100 1001 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1100 1010 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1100 1011 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1100 1100 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1100 1101 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1100 1110 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1100 1111 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1101 0000 0000
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,

    // 0011 1101 0001 0000
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,

    // 0011 1101 0010 0000
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,

    // 0011 1101 0011 0000
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,

    // 0011 1101 0100 0000
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,

    // 0011 1101 0101 0000
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,

    // 0011 1101 0110 0000
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,

    // 0011 1101 0111 0000
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,

    // 0011 1101 1000 0000
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,

    // 0011 1101 1001 0000
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,

    // 0011 1101 1010 0000
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,

    // 0011 1101 1011 0000
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,

    // 0011 1101 1100 0000
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,

    // 0011 1101 1101 0000
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,

    // 0011 1101 1110 0000
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,

    // 0011 1101 1111 0000
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,
    OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00, OP_GLUE_3D00,

    // 0011 1110 0000 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1110 0001 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1110 0010 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1110 0011 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1110 0100 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1110 0101 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1110 0110 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1110 0111 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1110 1000 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1110 1001 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1110 1010 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1110 1011 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1110 1100 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1110 1101 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1110 1110 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1110 1111 0000
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,
    OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000, OP_GLUE_3000,

    // 0011 1111 0000 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1111 0001 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1111 0010 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1111 0011 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1111 0100 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1111 0101 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1111 0110 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1111 0111 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1111 1000 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1111 1001 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1111 1010 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1111 1011 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1111 1100 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1111 1101 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1111 1110 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0011 1111 1111 0000
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,
    OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300, OP_GLUE_2300,

    // 0100 0000 0000 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0000 0001 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0000 0010 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0000 0011 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0000 0100 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0000 0101 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0000 0110 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0000 0111 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0000 1000 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0000 1001 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0000 1010 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0000 1011 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0000 1100 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0000 1101 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0000 1110 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0000 1111 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0001 0000 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0001 0001 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0001 0010 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0001 0011 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0001 0100 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0001 0101 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0001 0110 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0001 0111 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0001 1000 0000
    OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180,
    OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180,
    OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180,
    OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180,

    // 0100 0001 1001 0000
    OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180,
    OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180,
    OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180,
    OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180,

    // 0100 0001 1010 0000
    OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180,
    OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180,
    OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180,
    OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180,

    // 0100 0001 1011 0000
    OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180,
    OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180,
    OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180,
    OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180, OP_GLUE_4180,

    // 0100 0001 1100 0000
    OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0,
    OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0,
    OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0,
    OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0,

    // 0100 0001 1101 0000
    OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0,
    OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0,
    OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0,
    OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0,

    // 0100 0001 1110 0000
    OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0,
    OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0,
    OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0,
    OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0,

    // 0100 0001 1111 0000
    OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0,
    OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0,
    OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0,
    OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0, OP_GLUE_41C0,

    // 0100 0010 0000 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0010 0001 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0010 0010 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0010 0011 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0010 0100 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0010 0101 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0010 0110 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0010 0111 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0010 1000 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0010 1001 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0010 1010 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0010 1011 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0010 1100 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0010 1101 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0010 1110 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0010 1111 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0011 0000 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0011 0001 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0011 0010 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0011 0011 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0011 0100 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0011 0101 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0011 0110 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0011 0111 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0011 1000 0000
    OP_GLUE_4380, OP_GLUE_4381, OP_GLUE_4382, OP_GLUE_4382,
    OP_GLUE_4384, OP_GLUE_4384, OP_GLUE_4384, OP_GLUE_4384,
    OP_GLUE_4388, OP_GLUE_4388, OP_GLUE_4388, OP_GLUE_4388,
    OP_GLUE_4388, OP_GLUE_4388, OP_GLUE_4388, OP_GLUE_4388,

    // 0100 0011 1001 0000
    OP_GLUE_4390, OP_GLUE_4390, OP_GLUE_4390, OP_GLUE_4390,
    OP_GLUE_4390, OP_GLUE_4390, OP_GLUE_4390, OP_GLUE_4390,
    OP_GLUE_4390, OP_GLUE_4390, OP_GLUE_4390, OP_GLUE_4390,
    OP_GLUE_4390, OP_GLUE_4390, OP_GLUE_4390, OP_GLUE_4390,

    // 0100 0011 1010 0000
    OP_GLUE_43A0, OP_GLUE_43A0, OP_GLUE_43A0, OP_GLUE_43A0,
    OP_GLUE_43A0, OP_GLUE_43A0, OP_GLUE_43A0, OP_GLUE_43A0,
    OP_GLUE_43A0, OP_GLUE_43A0, OP_GLUE_43A0, OP_GLUE_43A0,
    OP_GLUE_43A0, OP_GLUE_43A0, OP_GLUE_43A0, OP_GLUE_43A0,

    // 0100 0011 1011 0000
    OP_GLUE_43A0, OP_GLUE_43A0, OP_GLUE_43A0, OP_GLUE_43A0,
    OP_GLUE_43A0, OP_GLUE_43A0, OP_GLUE_43A0, OP_GLUE_43A0,
    OP_GLUE_43A0, OP_GLUE_43A0, OP_GLUE_43A0, OP_GLUE_43A0,
    OP_GLUE_43A0, OP_GLUE_43A0, OP_GLUE_43A0, OP_GLUE_43A0,

    // 0100 0011 1100 0000
    OP_GLUE_43C0, OP_GLUE_43C1, OP_GLUE_43C2, OP_GLUE_43C2,
    OP_GLUE_4384, OP_GLUE_4384, OP_GLUE_4384, OP_GLUE_4384,
    OP_GLUE_43C8, OP_GLUE_43C8, OP_GLUE_43C8, OP_GLUE_43C8,
    OP_GLUE_43C8, OP_GLUE_43C8, OP_GLUE_43C8, OP_GLUE_43C8,

    // 0100 0011 1101 0000
    OP_GLUE_4390, OP_GLUE_4390, OP_GLUE_4390, OP_GLUE_4390,
    OP_GLUE_4390, OP_GLUE_4390, OP_GLUE_4390, OP_GLUE_4390,
    OP_GLUE_4390, OP_GLUE_4390, OP_GLUE_4390, OP_GLUE_4390,
    OP_GLUE_4390, OP_GLUE_4390, OP_GLUE_4390, OP_GLUE_4390,

    // 0100 0011 1110 0000
    OP_GLUE_43E0, OP_GLUE_43E0, OP_GLUE_43E0, OP_GLUE_43E0,
    OP_GLUE_43E0, OP_GLUE_43E0, OP_GLUE_43E0, OP_GLUE_43E0,
    OP_GLUE_43E0, OP_GLUE_43E0, OP_GLUE_43E0, OP_GLUE_43E0,
    OP_GLUE_43E0, OP_GLUE_43E0, OP_GLUE_43E0, OP_GLUE_43E0,

    // 0100 0011 1111 0000
    OP_GLUE_43E0, OP_GLUE_43E0, OP_GLUE_43E0, OP_GLUE_43E0,
    OP_GLUE_43E0, OP_GLUE_43E0, OP_GLUE_43E0, OP_GLUE_43E0,
    OP_GLUE_43E0, OP_GLUE_43E0, OP_GLUE_43E0, OP_GLUE_43E0,
    OP_GLUE_43E0, OP_GLUE_43E0, OP_GLUE_43E0, OP_GLUE_43E0,

    // 0100 0100 0000 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0100 0001 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0100 0010 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0100 0011 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0100 0100 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0100 0101 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0100 0110 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0100 0111 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0100 1000 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0100 1001 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0100 1010 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0100 1011 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0100 1100 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0100 1101 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0100 1110 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0100 1111 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0101 0000 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0101 0001 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0101 0010 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0101 0011 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0101 0100 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0101 0101 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0101 0110 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0101 0111 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0101 1000 0000
    OP_GLUE_4580, OP_GLUE_4580, OP_GLUE_4580, OP_GLUE_4580,
    OP_GLUE_4580, OP_GLUE_4580, OP_GLUE_4580, OP_GLUE_4580,
    OP_GLUE_4580, OP_GLUE_4580, OP_GLUE_4580, OP_GLUE_4580,
    OP_GLUE_4580, OP_GLUE_4580, OP_GLUE_4580, OP_GLUE_4580,

    // 0100 0101 1001 0000
    OP_GLUE_4590, OP_UNDEFINED, OP_GLUE_4592, OP_GLUE_4593,
    OP_GLUE_4590, OP_UNDEFINED, OP_GLUE_4592, OP_GLUE_4593,
    OP_GLUE_4590, OP_UNDEFINED, OP_GLUE_4592, OP_GLUE_4593,
    OP_GLUE_4590, OP_UNDEFINED, OP_GLUE_4592, OP_GLUE_4593,

    // 0100 0101 1010 0000
    OP_GLUE_45A0, OP_GLUE_45A0, OP_GLUE_45A0, OP_GLUE_45A0,
    OP_GLUE_45A0, OP_GLUE_45A0, OP_GLUE_45A0, OP_GLUE_45A0,
    OP_GLUE_45A0, OP_GLUE_45A0, OP_GLUE_45A0, OP_GLUE_45A0,
    OP_GLUE_45A0, OP_GLUE_45A0, OP_GLUE_45A0, OP_GLUE_45A0,

    // 0100 0101 1011 0000
    OP_GLUE_45A0, OP_GLUE_45A0, OP_GLUE_45A0, OP_GLUE_45A0,
    OP_GLUE_45A0, OP_GLUE_45A0, OP_GLUE_45A0, OP_GLUE_45A0,
    OP_GLUE_45A0, OP_GLUE_45A0, OP_GLUE_45A0, OP_GLUE_45A0,
    OP_GLUE_45A0, OP_GLUE_45A0, OP_GLUE_45A0, OP_GLUE_45A0,

    // 0100 0101 1100 0000
    OP_GLUE_45C0, OP_GLUE_45C0, OP_GLUE_45C0, OP_GLUE_45C0,
    OP_GLUE_45C0, OP_GLUE_45C0, OP_GLUE_45C0, OP_GLUE_45C0,
    OP_GLUE_45C0, OP_GLUE_45C0, OP_GLUE_45C0, OP_GLUE_45C0,
    OP_GLUE_45C0, OP_GLUE_45C0, OP_GLUE_45C0, OP_GLUE_45C0,

    // 0100 0101 1101 0000
    OP_GLUE_45D0, OP_GLUE_45D0, OP_GLUE_45D0, OP_GLUE_45D0,
    OP_GLUE_45D0, OP_GLUE_45D0, OP_GLUE_45D0, OP_GLUE_45D0,
    OP_GLUE_45D0, OP_GLUE_45D0, OP_GLUE_45D0, OP_GLUE_45D0,
    OP_GLUE_45D0, OP_GLUE_45D0, OP_GLUE_45D0, OP_GLUE_45D0,

    // 0100 0101 1110 0000
    OP_GLUE_45E0, OP_GLUE_45E0, OP_GLUE_45E0, OP_GLUE_45E0,
    OP_GLUE_45E0, OP_GLUE_45E0, OP_GLUE_45E0, OP_GLUE_45E0,
    OP_GLUE_45E0, OP_GLUE_45E0, OP_GLUE_45E0, OP_GLUE_45E0,
    OP_GLUE_45E0, OP_GLUE_45E0, OP_GLUE_45E0, OP_GLUE_45E0,

    // 0100 0101 1111 0000
    OP_GLUE_45E0, OP_GLUE_45E0, OP_GLUE_45E0, OP_GLUE_45E0,
    OP_GLUE_45E0, OP_GLUE_45E0, OP_GLUE_45E0, OP_GLUE_45E0,
    OP_GLUE_45E0, OP_GLUE_45E0, OP_GLUE_45E0, OP_GLUE_45E0,
    OP_GLUE_45E0, OP_GLUE_45E0, OP_GLUE_45E0, OP_GLUE_45E0,

    // 0100 0110 0000 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0110 0001 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0110 0010 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0110 0011 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0110 0100 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0110 0101 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0110 0110 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0110 0111 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0110 1000 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0110 1001 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0110 1010 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0110 1011 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0110 1100 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0110 1101 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0110 1110 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0110 1111 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 0111 0000 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0111 0001 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0111 0010 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0111 0011 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0111 0100 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0111 0101 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0111 0110 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0111 0111 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 0111 1000 0000
    OP_GLUE_4780, OP_GLUE_4780, OP_GLUE_4780, OP_GLUE_4780,
    OP_GLUE_4780, OP_GLUE_4780, OP_GLUE_4780, OP_GLUE_4780,
    OP_GLUE_4780, OP_GLUE_4780, OP_GLUE_4780, OP_GLUE_4780,
    OP_GLUE_4780, OP_GLUE_4780, OP_GLUE_4780, OP_GLUE_4780,

    // 0100 0111 1001 0000
    OP_GLUE_4780, OP_GLUE_4780, OP_GLUE_4780, OP_GLUE_4780,
    OP_GLUE_4780, OP_GLUE_4780, OP_GLUE_4780, OP_GLUE_4780,
    OP_GLUE_4780, OP_GLUE_4780, OP_GLUE_4780, OP_GLUE_4780,
    OP_GLUE_4780, OP_GLUE_4780, OP_GLUE_4780, OP_GLUE_4780,

    // 0100 0111 1010 0000
    OP_GLUE_47A0, OP_GLUE_47A0, OP_GLUE_47A0, OP_GLUE_47A0,
    OP_GLUE_47A4, OP_GLUE_47A4, OP_GLUE_47A4, OP_GLUE_47A4,
    OP_GLUE_47A0, OP_GLUE_47A0, OP_GLUE_47A0, OP_GLUE_47A0,
    OP_GLUE_47A4, OP_GLUE_47A4, OP_GLUE_47A4, OP_GLUE_47A4,

    // 0100 0111 1011 0000
    OP_GLUE_47B0, OP_GLUE_47B0, OP_GLUE_47B0, OP_GLUE_47B0,
    OP_GLUE_47B4, OP_GLUE_47B4, OP_GLUE_47B4, OP_GLUE_47B4,
    OP_GLUE_47B8, OP_GLUE_47B8, OP_GLUE_47B8, OP_GLUE_47B8,
    OP_GLUE_47B8, OP_GLUE_47B8, OP_GLUE_47B8, OP_GLUE_47B8,

    // 0100 0111 1100 0000
    OP_GLUE_47C0, OP_GLUE_47C0, OP_GLUE_47C0, OP_GLUE_47C0,
    OP_GLUE_47C0, OP_GLUE_47C0, OP_GLUE_47C0, OP_GLUE_47C0,
    OP_GLUE_47C0, OP_GLUE_47C0, OP_GLUE_47C0, OP_GLUE_47C0,
    OP_GLUE_47C0, OP_GLUE_47C0, OP_GLUE_47C0, OP_GLUE_47C0,

    // 0100 0111 1101 0000
    OP_GLUE_47C0, OP_GLUE_47C0, OP_GLUE_47C0, OP_GLUE_47C0,
    OP_GLUE_47C0, OP_GLUE_47C0, OP_GLUE_47C0, OP_GLUE_47C0,
    OP_GLUE_47C0, OP_GLUE_47C0, OP_GLUE_47C0, OP_GLUE_47C0,
    OP_GLUE_47C0, OP_GLUE_47C0, OP_GLUE_47C0, OP_GLUE_47C0,

    // 0100 0111 1110 0000
    OP_GLUE_47E0, OP_GLUE_47E0, OP_GLUE_47E0, OP_GLUE_47E0,
    OP_GLUE_47E0, OP_GLUE_47E0, OP_GLUE_47E0, OP_GLUE_47E0,
    OP_GLUE_47E0, OP_GLUE_47E0, OP_GLUE_47E0, OP_GLUE_47E0,
    OP_GLUE_47E0, OP_GLUE_47E0, OP_GLUE_47E0, OP_GLUE_47E0,

    // 0100 0111 1111 0000
    OP_GLUE_47E0, OP_GLUE_47E0, OP_GLUE_47E0, OP_GLUE_47E0,
    OP_GLUE_47E0, OP_GLUE_47E0, OP_GLUE_47E0, OP_GLUE_47E0,
    OP_GLUE_47E0, OP_GLUE_47E0, OP_GLUE_47E0, OP_GLUE_47E0,
    OP_GLUE_47E0, OP_GLUE_47E0, OP_GLUE_47E0, OP_GLUE_47E0,

    // 0100 1000 0000 0000
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,

    // 0100 1000 0001 0000
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,

    // 0100 1000 0010 0000
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,

    // 0100 1000 0011 0000
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,

    // 0100 1000 0100 0000
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,

    // 0100 1000 0101 0000
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,

    // 0100 1000 0110 0000
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,

    // 0100 1000 0111 0000
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,
    OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800, OP_GLUE_4800,

    // 0100 1000 1000 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1000 1001 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1000 1010 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1000 1011 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1000 1100 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1000 1101 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1000 1110 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1000 1111 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1001 0000 0000
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,

    // 0100 1001 0001 0000
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,

    // 0100 1001 0010 0000
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,

    // 0100 1001 0011 0000
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,

    // 0100 1001 0100 0000
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,

    // 0100 1001 0101 0000
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,

    // 0100 1001 0110 0000
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,

    // 0100 1001 0111 0000
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,
    OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900, OP_GLUE_4900,

    // 0100 1001 1000 0000
    OP_GLUE_4980, OP_GLUE_4980, OP_GLUE_4980, OP_GLUE_4980,
    OP_GLUE_4980, OP_GLUE_4980, OP_GLUE_4980, OP_GLUE_4980,
    OP_GLUE_4980, OP_GLUE_4980, OP_GLUE_4980, OP_GLUE_4980,
    OP_GLUE_4980, OP_GLUE_4980, OP_GLUE_4980, OP_GLUE_4980,

    // 0100 1001 1001 0000
    OP_GLUE_4990, OP_GLUE_4990, OP_GLUE_4990, OP_GLUE_4990,
    OP_GLUE_4990, OP_GLUE_4990, OP_GLUE_4990, OP_GLUE_4990,
    OP_GLUE_4998, OP_GLUE_4998, OP_GLUE_4998, OP_GLUE_4998,
    OP_GLUE_4998, OP_GLUE_4998, OP_GLUE_4998, OP_GLUE_4998,

    // 0100 1001 1010 0000
    OP_GLUE_49A0, OP_GLUE_49A0, OP_GLUE_49A0, OP_GLUE_49A0,
    OP_GLUE_49A0, OP_GLUE_49A0, OP_GLUE_49A0, OP_GLUE_49A0,
    OP_GLUE_49A0, OP_GLUE_49A0, OP_GLUE_49A0, OP_GLUE_49A0,
    OP_GLUE_49A0, OP_GLUE_49A0, OP_GLUE_49A0, OP_GLUE_49A0,

    // 0100 1001 1011 0000
    OP_GLUE_49A0, OP_GLUE_49A0, OP_GLUE_49A0, OP_GLUE_49A0,
    OP_GLUE_49A0, OP_GLUE_49A0, OP_GLUE_49A0, OP_GLUE_49A0,
    OP_GLUE_49A0, OP_GLUE_49A0, OP_GLUE_49A0, OP_GLUE_49A0,
    OP_GLUE_49A0, OP_GLUE_49A0, OP_GLUE_49A0, OP_GLUE_49A0,

    // 0100 1001 1100 0000
    OP_GLUE_49C0, OP_GLUE_49C1, OP_GLUE_49C2, OP_GLUE_49C3,
    OP_GLUE_49C4, OP_GLUE_49C4, OP_GLUE_49C4, OP_GLUE_49C4,
    OP_GLUE_49C8, OP_GLUE_49C8, OP_GLUE_49C8, OP_GLUE_49C8,
    OP_GLUE_49C8, OP_GLUE_49C8, OP_GLUE_49C8, OP_GLUE_49C8,

    // 0100 1001 1101 0000
    OP_GLUE_49C0, OP_GLUE_49C1, OP_GLUE_49C2, OP_GLUE_49C3,
    OP_GLUE_49C4, OP_GLUE_49C4, OP_GLUE_49C4, OP_GLUE_49C4,
    OP_GLUE_49C8, OP_GLUE_49C8, OP_GLUE_49C8, OP_GLUE_49C8,
    OP_GLUE_49C8, OP_GLUE_49C8, OP_GLUE_49C8, OP_GLUE_49C8,

    // 0100 1001 1110 0000
    OP_GLUE_49C0, OP_GLUE_49C1, OP_GLUE_49C2, OP_GLUE_49C3,
    OP_GLUE_49C4, OP_GLUE_49C4, OP_GLUE_49C4, OP_GLUE_49C4,
    OP_GLUE_49C8, OP_GLUE_49C8, OP_GLUE_49C8, OP_GLUE_49C8,
    OP_GLUE_49C8, OP_GLUE_49C8, OP_GLUE_49C8, OP_GLUE_49C8,

    // 0100 1001 1111 0000
    OP_GLUE_49C0, OP_GLUE_49C1, OP_GLUE_49C2, OP_GLUE_49C3,
    OP_GLUE_49C4, OP_GLUE_49C4, OP_GLUE_49C4, OP_GLUE_49C4,
    OP_GLUE_49C8, OP_GLUE_49C8, OP_GLUE_49C8, OP_GLUE_49C8,
    OP_GLUE_49C8, OP_GLUE_49C8, OP_GLUE_49C8, OP_GLUE_49C8,

    // 0100 1010 0000 0000
    OP_GLUE_4A00, OP_GLUE_4A00, OP_GLUE_4A00, OP_GLUE_4A00,
    OP_GLUE_4A04, OP_GLUE_4A04, OP_GLUE_4A04, OP_GLUE_4A04,
    OP_GLUE_4A00, OP_GLUE_4A00, OP_GLUE_4A00, OP_GLUE_4A00,
    OP_GLUE_4A04, OP_GLUE_4A04, OP_GLUE_4A04, OP_GLUE_4A04,

    // 0100 1010 0001 0000
    OP_GLUE_4A00, OP_GLUE_4A00, OP_GLUE_4A00, OP_GLUE_4A00,
    OP_GLUE_4A04, OP_GLUE_4A04, OP_GLUE_4A04, OP_GLUE_4A04,
    OP_GLUE_4A00, OP_GLUE_4A00, OP_GLUE_4A00, OP_GLUE_4A00,
    OP_GLUE_4A04, OP_GLUE_4A04, OP_GLUE_4A04, OP_GLUE_4A04,

    // 0100 1010 0010 0000
    OP_GLUE_4A20, OP_GLUE_4A20, OP_GLUE_4A20, OP_GLUE_4A20,
    OP_GLUE_4A24, OP_GLUE_4A24, OP_GLUE_4A24, OP_GLUE_4A24,
    OP_GLUE_4A20, OP_GLUE_4A20, OP_GLUE_4A20, OP_GLUE_4A20,
    OP_GLUE_4A24, OP_GLUE_4A24, OP_GLUE_4A24, OP_GLUE_4A24,

    // 0100 1010 0011 0000
    OP_GLUE_4A20, OP_GLUE_4A20, OP_GLUE_4A20, OP_GLUE_4A20,
    OP_GLUE_4A24, OP_GLUE_4A24, OP_GLUE_4A24, OP_GLUE_4A24,
    OP_GLUE_4A20, OP_GLUE_4A20, OP_GLUE_4A20, OP_GLUE_4A20,
    OP_GLUE_4A24, OP_GLUE_4A24, OP_GLUE_4A24, OP_GLUE_4A24,

    // 0100 1010 0100 0000
    OP_GLUE_4A40, OP_GLUE_4A40, OP_GLUE_4A40, OP_GLUE_4A40,
    OP_GLUE_4A44, OP_GLUE_4A44, OP_GLUE_4A44, OP_GLUE_4A44,
    OP_GLUE_4A40, OP_GLUE_4A40, OP_GLUE_4A40, OP_GLUE_4A40,
    OP_GLUE_4A44, OP_GLUE_4A44, OP_GLUE_4A44, OP_GLUE_4A44,

    // 0100 1010 0101 0000
    OP_GLUE_4A40, OP_GLUE_4A40, OP_GLUE_4A40, OP_GLUE_4A40,
    OP_GLUE_4A44, OP_GLUE_4A44, OP_GLUE_4A44, OP_GLUE_4A44,
    OP_GLUE_4A40, OP_GLUE_4A40, OP_GLUE_4A40, OP_GLUE_4A40,
    OP_GLUE_4A44, OP_GLUE_4A44, OP_GLUE_4A44, OP_GLUE_4A44,

    // 0100 1010 0110 0000
    OP_GLUE_4A60, OP_GLUE_4A60, OP_GLUE_4A60, OP_GLUE_4A60,
    OP_GLUE_4A64, OP_GLUE_4A64, OP_GLUE_4A64, OP_GLUE_4A64,
    OP_GLUE_4A60, OP_GLUE_4A60, OP_GLUE_4A60, OP_GLUE_4A60,
    OP_GLUE_4A64, OP_GLUE_4A64, OP_GLUE_4A64, OP_GLUE_4A64,

    // 0100 1010 0111 0000
    OP_GLUE_4A60, OP_GLUE_4A60, OP_GLUE_4A60, OP_GLUE_4A60,
    OP_GLUE_4A64, OP_GLUE_4A64, OP_GLUE_4A64, OP_GLUE_4A64,
    OP_GLUE_4A60, OP_GLUE_4A60, OP_GLUE_4A60, OP_GLUE_4A60,
    OP_GLUE_4A64, OP_GLUE_4A64, OP_GLUE_4A64, OP_GLUE_4A64,

    // 0100 1010 1000 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1010 1001 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1010 1010 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1010 1011 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1010 1100 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1010 1101 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1010 1110 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1010 1111 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1011 0000 0000
    OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00,
    OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00,
    OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00,
    OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00,

    // 0100 1011 0001 0000
    OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00,
    OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00,
    OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00,
    OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00,

    // 0100 1011 0010 0000
    OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00,
    OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00,
    OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00,
    OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00,

    // 0100 1011 0011 0000
    OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00,
    OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00,
    OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00,
    OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00, OP_GLUE_4B00,

    // 0100 1011 0100 0000
    OP_GLUE_4B40, OP_GLUE_4B40, OP_GLUE_4B42, OP_GLUE_4B42,
    OP_GLUE_4B40, OP_GLUE_4B40, OP_GLUE_4B42, OP_GLUE_4B42,
    OP_GLUE_4B40, OP_GLUE_4B40, OP_GLUE_4B42, OP_GLUE_4B42,
    OP_GLUE_4B40, OP_GLUE_4B40, OP_GLUE_4B42, OP_GLUE_4B42,

    // 0100 1011 0101 0000
    OP_GLUE_4B50, OP_GLUE_4B50, OP_GLUE_4B50, OP_GLUE_4B50,
    OP_GLUE_4B50, OP_GLUE_4B50, OP_GLUE_4B50, OP_GLUE_4B50,
    OP_GLUE_4B50, OP_GLUE_4B50, OP_GLUE_4B50, OP_GLUE_4B50,
    OP_GLUE_4B50, OP_GLUE_4B50, OP_GLUE_4B50, OP_GLUE_4B50,

    // 0100 1011 0110 0000
    OP_GLUE_4B60, OP_GLUE_4B60, OP_GLUE_4B60, OP_GLUE_4B60,
    OP_GLUE_4B60, OP_GLUE_4B60, OP_GLUE_4B60, OP_GLUE_4B60,
    OP_GLUE_4B60, OP_GLUE_4B60, OP_GLUE_4B60, OP_GLUE_4B60,
    OP_GLUE_4B60, OP_GLUE_4B60, OP_GLUE_4B60, OP_GLUE_4B60,

    // 0100 1011 0111 0000
    OP_GLUE_4B60, OP_GLUE_4B60, OP_GLUE_4B60, OP_GLUE_4B60,
    OP_GLUE_4B60, OP_GLUE_4B60, OP_GLUE_4B60, OP_GLUE_4B60,
    OP_GLUE_4B60, OP_GLUE_4B60, OP_GLUE_4B60, OP_GLUE_4B60,
    OP_GLUE_4B60, OP_GLUE_4B60, OP_GLUE_4B60, OP_GLUE_4B60,

    // 0100 1011 1000 0000
    OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80,
    OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80,
    OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80,
    OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80,

    // 0100 1011 1001 0000
    OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80,
    OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80,
    OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80,
    OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80,

    // 0100 1011 1010 0000
    OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80,
    OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80,
    OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80,
    OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80,

    // 0100 1011 1011 0000
    OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80,
    OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80,
    OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80,
    OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80, OP_GLUE_4B80,

    // 0100 1011 1100 0000
    OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0,
    OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0,
    OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0,
    OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0,

    // 0100 1011 1101 0000
    OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0,
    OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0,
    OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0,
    OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0,

    // 0100 1011 1110 0000
    OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0,
    OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0,
    OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0,
    OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0,

    // 0100 1011 1111 0000
    OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0,
    OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0,
    OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0,
    OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0, OP_GLUE_4BC0,

    // 0100 1100 0000 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1100 0001 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1100 0010 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1100 0011 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1100 0100 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1100 0101 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1100 0110 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1100 0111 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1100 1000 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1100 1001 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1100 1010 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1100 1011 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1100 1100 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1100 1101 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1100 1110 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1100 1111 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1101 0000 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1101 0001 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1101 0010 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1101 0011 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1101 0100 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1101 0101 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1101 0110 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1101 0111 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1101 1000 0000
    OP_GLUE_4D80, OP_GLUE_4D80, OP_GLUE_4D80, OP_GLUE_4D80,
    OP_GLUE_4D84, OP_GLUE_4D84, OP_GLUE_4D84, OP_GLUE_4D84,
    OP_GLUE_4D88, OP_GLUE_4D89, OP_GLUE_4D88, OP_GLUE_4D89,
    OP_GLUE_4D8C, OP_GLUE_4D8C, OP_GLUE_4D8C, OP_GLUE_4D8C,

    // 0100 1101 1001 0000
    OP_GLUE_4D90, OP_GLUE_4D90, OP_GLUE_4D90, OP_GLUE_4D90,
    OP_GLUE_4D90, OP_GLUE_4D90, OP_GLUE_4D90, OP_GLUE_4D90,
    OP_GLUE_4D90, OP_GLUE_4D90, OP_GLUE_4D90, OP_GLUE_4D90,
    OP_GLUE_4D90, OP_GLUE_4D90, OP_GLUE_4D90, OP_GLUE_4D90,

    // 0100 1101 1010 0000
    OP_GLUE_4DA0, OP_GLUE_4DA1, OP_GLUE_4DA2, OP_GLUE_4DA3,
    OP_GLUE_4DA0, OP_GLUE_4DA1, OP_GLUE_4DA2, OP_GLUE_4DA3,
    OP_GLUE_4DA0, OP_GLUE_4DA1, OP_GLUE_4DA2, OP_GLUE_4DA3,
    OP_GLUE_4DA0, OP_GLUE_4DA1, OP_GLUE_4DA2, OP_GLUE_4DA3,

    // 0100 1101 1011 0000
    OP_GLUE_4DA0, OP_GLUE_4DA1, OP_GLUE_4DA2, OP_GLUE_4DA3,
    OP_GLUE_4DA0, OP_GLUE_4DA1, OP_GLUE_4DA2, OP_GLUE_4DA3,
    OP_GLUE_4DA0, OP_GLUE_4DA1, OP_GLUE_4DA2, OP_GLUE_4DA3,
    OP_GLUE_4DA0, OP_GLUE_4DA1, OP_GLUE_4DA2, OP_GLUE_4DA3,

    // 0100 1101 1100 0000
    OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0,
    OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0,
    OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0,
    OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0,

    // 0100 1101 1101 0000
    OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0,
    OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0,
    OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0,
    OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0,

    // 0100 1101 1110 0000
    OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0,
    OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0,
    OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0,
    OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0,

    // 0100 1101 1111 0000
    OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0,
    OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0,
    OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0,
    OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0, OP_GLUE_4DC0,

    // 0100 1110 0000 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1110 0001 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1110 0010 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1110 0011 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1110 0100 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1110 0101 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1110 0110 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1110 0111 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1110 1000 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1110 1001 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1110 1010 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1110 1011 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1110 1100 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1110 1101 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1110 1110 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1110 1111 0000
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,
    OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080, OP_GLUE_4080,

    // 0100 1111 0000 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1111 0001 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1111 0010 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1111 0011 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1111 0100 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1111 0101 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1111 0110 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1111 0111 0000
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,
    OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000, OP_GLUE_4000,

    // 0100 1111 1000 0000
    OP_GLUE_4F80, OP_GLUE_4F80, OP_GLUE_4F80, OP_GLUE_4F80,
    OP_GLUE_4F80, OP_GLUE_4F80, OP_GLUE_4F80, OP_GLUE_4F80,
    OP_GLUE_4F80, OP_GLUE_4F80, OP_GLUE_4F80, OP_GLUE_4F80,
    OP_GLUE_4F80, OP_GLUE_4F80, OP_GLUE_4F80, OP_GLUE_4F80,

    // 0100 1111 1001 0000
    OP_GLUE_4F80, OP_GLUE_4F80, OP_GLUE_4F80, OP_GLUE_4F80,
    OP_GLUE_4F80, OP_GLUE_4F80, OP_GLUE_4F80, OP_GLUE_4F80,
    OP_GLUE_4F80, OP_GLUE_4F80, OP_GLUE_4F80, OP_GLUE_4F80,
    OP_GLUE_4F80, OP_GLUE_4F80, OP_GLUE_4F80, OP_GLUE_4F80,

    // 0100 1111 1010 0000
    OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0,
    OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0,
    OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0,
    OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0,

    // 0100 1111 1011 0000
    OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0,
    OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0,
    OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0,
    OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0,

    // 0100 1111 1100 0000
    OP_GLUE_4FC0, OP_GLUE_4FC0, OP_GLUE_4FC0, OP_GLUE_4FC0,
    OP_GLUE_4FC0, OP_GLUE_4FC0, OP_GLUE_4FC0, OP_GLUE_4FC0,
    OP_GLUE_4FC0, OP_GLUE_4FC0, OP_GLUE_4FC0, OP_GLUE_4FC0,
    OP_GLUE_4FC0, OP_GLUE_4FC0, OP_GLUE_4FC0, OP_GLUE_4FC0,

    // 0100 1111 1101 0000
    OP_GLUE_4FC0, OP_GLUE_4FC0, OP_GLUE_4FC0, OP_GLUE_4FC0,
    OP_GLUE_4FC0, OP_GLUE_4FC0, OP_GLUE_4FC0, OP_GLUE_4FC0,
    OP_GLUE_4FC0, OP_GLUE_4FC0, OP_GLUE_4FC0, OP_GLUE_4FC0,
    OP_GLUE_4FC0, OP_GLUE_4FC0, OP_GLUE_4FC0, OP_GLUE_4FC0,

    // 0100 1111 1110 0000
    OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0,
    OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0,
    OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0,
    OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0,

    // 0100 1111 1111 0000
    OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0,
    OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0,
    OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0,
    OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0, OP_GLUE_4FA0,

    // 0101 0000 0000 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0000 0001 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0000 0010 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0000 0011 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0000 0100 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0000 0101 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0000 0110 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0000 0111 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0000 1000 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0000 1001 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0000 1010 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0000 1011 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0000 1100 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0000 1101 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0000 1110 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0000 1111 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0001 0000 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0001 0001 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0001 0010 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0001 0011 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0001 0100 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0001 0101 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0001 0110 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0001 0111 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0001 1000 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0001 1001 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0001 1010 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0001 1011 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0001 1100 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0001 1101 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0001 1110 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0001 1111 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0010 0000 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0010 0001 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0010 0010 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0010 0011 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0010 0100 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0010 0101 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0010 0110 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0010 0111 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0010 1000 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0010 1001 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0010 1010 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0010 1011 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0010 1100 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0010 1101 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0010 1110 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0010 1111 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0011 0000 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0011 0001 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0011 0010 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0011 0011 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0011 0100 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0011 0101 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0011 0110 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0011 0111 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0011 1000 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0011 1001 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0011 1010 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0011 1011 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0011 1100 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0011 1101 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0011 1110 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0011 1111 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0100 0000 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0100 0001 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0100 0010 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0100 0011 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0100 0100 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0100 0101 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0100 0110 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0100 0111 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0100 1000 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0100 1001 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0100 1010 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0100 1011 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0100 1100 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0100 1101 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0100 1110 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0100 1111 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0101 0000 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0101 0001 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0101 0010 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0101 0011 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0101 0100 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0101 0101 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0101 0110 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0101 0111 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0101 1000 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0101 1001 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0101 1010 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0101 1011 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0101 1100 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0101 1101 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0101 1110 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0101 1111 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0110 0000 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0110 0001 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0110 0010 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0110 0011 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0110 0100 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0110 0101 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0110 0110 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0110 0111 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0110 1000 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0110 1001 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0110 1010 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0110 1011 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0110 1100 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0110 1101 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0110 1110 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0110 1111 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0111 0000 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0111 0001 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0111 0010 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0111 0011 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0111 0100 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0111 0101 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0111 0110 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0111 0111 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0111 1000 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0111 1001 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0111 1010 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0111 1011 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0111 1100 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0111 1101 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0111 1110 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 0111 1111 0000
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,
    OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000, OP_GLUE_5000,

    // 0101 1000 0000 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1000 0001 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5818, OP_GLUE_5818, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1000 0010 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1000 0011 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5838, OP_GLUE_5838, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1000 0100 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1000 0101 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5818, OP_GLUE_5818, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1000 0110 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1000 0111 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5838, OP_GLUE_5838, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1000 1000 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1000 1001 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5818, OP_GLUE_5818, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1000 1010 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1000 1011 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5838, OP_GLUE_5838, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1000 1100 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1000 1101 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5818, OP_GLUE_5818, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1000 1110 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1000 1111 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5838, OP_GLUE_5838, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1001 0000 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1001 0001 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5818, OP_GLUE_5818, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1001 0010 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1001 0011 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5838, OP_GLUE_5838, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1001 0100 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1001 0101 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5818, OP_GLUE_5818, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1001 0110 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1001 0111 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5838, OP_GLUE_5838, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1001 1000 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1001 1001 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5818, OP_GLUE_5818, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1001 1010 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1001 1011 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5838, OP_GLUE_5838, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1001 1100 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1001 1101 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5818, OP_GLUE_5818, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1001 1110 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1001 1111 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5838, OP_GLUE_5838, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1010 0000 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1010 0001 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_UNDEFINED, OP_UNDEFINED, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1010 0010 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1010 0011 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_UNDEFINED, OP_UNDEFINED, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1010 0100 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1010 0101 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_UNDEFINED, OP_UNDEFINED, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1010 0110 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1010 0111 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_UNDEFINED, OP_UNDEFINED, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1010 1000 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1010 1001 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_UNDEFINED, OP_UNDEFINED, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1010 1010 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1010 1011 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_UNDEFINED, OP_UNDEFINED, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1010 1100 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1010 1101 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_UNDEFINED, OP_UNDEFINED, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1010 1110 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1010 1111 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_UNDEFINED, OP_UNDEFINED, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1011 0000 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1011 0001 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_UNDEFINED, OP_UNDEFINED, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1011 0010 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1011 0011 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_UNDEFINED, OP_UNDEFINED, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1011 0100 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1011 0101 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_UNDEFINED, OP_UNDEFINED, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1011 0110 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1011 0111 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_UNDEFINED, OP_UNDEFINED, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1011 1000 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1011 1001 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_UNDEFINED, OP_UNDEFINED, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1011 1010 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1011 1011 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_UNDEFINED, OP_UNDEFINED, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1011 1100 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1011 1101 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_UNDEFINED, OP_UNDEFINED, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1011 1110 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1011 1111 0000
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,
    OP_UNDEFINED, OP_UNDEFINED, OP_GLUE_5800, OP_GLUE_5800,
    OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800, OP_GLUE_5800,

    // 0101 1100 0000 0000
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,

    // 0101 1100 0001 0000
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,

    // 0101 1100 0010 0000
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,

    // 0101 1100 0011 0000
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,

    // 0101 1100 0100 0000
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,

    // 0101 1100 0101 0000
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,

    // 0101 1100 0110 0000
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,

    // 0101 1100 0111 0000
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,

    // 0101 1100 1000 0000
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,

    // 0101 1100 1001 0000
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,

    // 0101 1100 1010 0000
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,

    // 0101 1100 1011 0000
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,

    // 0101 1100 1100 0000
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,

    // 0101 1100 1101 0000
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,

    // 0101 1100 1110 0000
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,

    // 0101 1100 1111 0000
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,
    OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00, OP_GLUE_5C00,

    // 0101 1101 0000 0000
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,

    // 0101 1101 0001 0000
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,

    // 0101 1101 0010 0000
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,

    // 0101 1101 0011 0000
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,

    // 0101 1101 0100 0000
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,

    // 0101 1101 0101 0000
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,

    // 0101 1101 0110 0000
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,

    // 0101 1101 0111 0000
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,
    OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00, OP_GLUE_5D00,

    // 0101 1101 1000 0000
    OP_GLUE_5D80, OP_GLUE_5D80, OP_GLUE_5D80, OP_GLUE_5D80,
    OP_GLUE_5D80, OP_GLUE_5D80, OP_GLUE_5D80, OP_GLUE_5D80,
    OP_GLUE_5D80, OP_GLUE_5D80, OP_GLUE_5D80, OP_GLUE_5D80,
    OP_GLUE_5D80, OP_GLUE_5D80, OP_GLUE_5D80, OP_GLUE_5D80,

    // 0101 1101 1001 0000
    OP_GLUE_5D80, OP_GLUE_5D80, OP_GLUE_5D80, OP_GLUE_5D80,
    OP_GLUE_5D80, OP_GLUE_5D80, OP_GLUE_5D80, OP_GLUE_5D80,
    OP_GLUE_5D80, OP_GLUE_5D80, OP_GLUE_5D80, OP_GLUE_5D80,
    OP_GLUE_5D80, OP_GLUE_5D80, OP_GLUE_5D80, OP_GLUE_5D80,

    // 0101 1101 1010 0000
    OP_GLUE_5DA0, OP_GLUE_5DA0, OP_GLUE_5DA0, OP_GLUE_5DA0,
    OP_GLUE_5DA0, OP_GLUE_5DA0, OP_GLUE_5DA0, OP_GLUE_5DA0,
    OP_GLUE_5DA8, OP_GLUE_5DA8, OP_GLUE_5DA8, OP_GLUE_5DA8,
    OP_GLUE_5DA8, OP_GLUE_5DA8, OP_GLUE_5DA8, OP_GLUE_5DA8,

    // 0101 1101 1011 0000
    OP_GLUE_5DB0, OP_GLUE_5DB0, OP_GLUE_5DB0, OP_GLUE_5DB0,
    OP_GLUE_5DB0, OP_GLUE_5DB0, OP_GLUE_5DB0, OP_GLUE_5DB0,
    OP_GLUE_5DB0, OP_GLUE_5DB0, OP_GLUE_5DB0, OP_GLUE_5DB0,
    OP_GLUE_5DB0, OP_GLUE_5DB0, OP_GLUE_5DB0, OP_GLUE_5DB0,

    // 0101 1101 1100 0000
    OP_GLUE_5DC0, OP_GLUE_5DC1, OP_GLUE_5DC2, OP_GLUE_5DC3,
    OP_GLUE_5DC0, OP_GLUE_5DC1, OP_GLUE_5DC2, OP_GLUE_5DC3,
    OP_GLUE_5DC0, OP_GLUE_5DC1, OP_GLUE_5DC2, OP_GLUE_5DC3,
    OP_GLUE_5DC0, OP_GLUE_5DC1, OP_GLUE_5DC2, OP_GLUE_5DC3,

    // 0101 1101 1101 0000
    OP_GLUE_5DD0, OP_GLUE_5DD0, OP_GLUE_5DD0, OP_GLUE_5DD0,
    OP_GLUE_5DD0, OP_GLUE_5DD0, OP_GLUE_5DD0, OP_GLUE_5DD0,
    OP_GLUE_5DD0, OP_GLUE_5DD0, OP_GLUE_5DD0, OP_GLUE_5DD0,
    OP_GLUE_5DD0, OP_GLUE_5DD0, OP_GLUE_5DD0, OP_GLUE_5DD0,

    // 0101 1101 1110 0000
    OP_GLUE_5DE0, OP_GLUE_5DE0, OP_GLUE_5DE0, OP_GLUE_5DE0,
    OP_GLUE_5DE0, OP_GLUE_5DE0, OP_GLUE_5DE0, OP_GLUE_5DE0,
    OP_GLUE_5DE0, OP_GLUE_5DE0, OP_GLUE_5DE0, OP_GLUE_5DE0,
    OP_GLUE_5DE0, OP_GLUE_5DE0, OP_GLUE_5DE0, OP_GLUE_5DE0,

    // 0101 1101 1111 0000
    OP_GLUE_5DF0, OP_GLUE_5DF0, OP_GLUE_5DF0, OP_GLUE_5DF0,
    OP_GLUE_5DF4, OP_GLUE_5DF4, OP_GLUE_5DF4, OP_GLUE_5DF4,
    OP_GLUE_5DF8, OP_GLUE_5DF8, OP_GLUE_5DF8, OP_GLUE_5DF8,
    OP_UNDEFINED, OP_GLUE_5DFD, OP_GLUE_5DFE, OP_GLUE_5DFF,

    // 0101 1110 0000 0000
    OP_GLUE_5E00, OP_GLUE_5E00, OP_GLUE_5E00, OP_GLUE_5E00,
    OP_GLUE_5E00, OP_GLUE_5E00, OP_GLUE_5E00, OP_GLUE_5E00,
    OP_GLUE_5E00, OP_GLUE_5E00, OP_GLUE_5E00, OP_GLUE_5E00,
    OP_GLUE_5E00, OP_GLUE_5E00, OP_GLUE_5E00, OP_GLUE_5E00,

    // 0101 1110 0001 0000
    OP_GLUE_5E00, OP_GLUE_5E00, OP_GLUE_5E00, OP_GLUE_5E00,
    OP_GLUE_5E00, OP_GLUE_5E00, OP_GLUE_5E00, OP_GLUE_5E00,
    OP_GLUE_5E00, OP_GLUE_5E00, OP_GLUE_5E00, OP_GLUE_5E00,
    OP_GLUE_5E00, OP_GLUE_5E00, OP_GLUE_5E00, OP_GLUE_5E00,

    // 0101 1110 0010 0000
    OP_GLUE_5E20, OP_GLUE_5E21, OP_GLUE_5E22, OP_GLUE_5E23,
    OP_GLUE_5E24, OP_GLUE_5E24, OP_GLUE_5E24, OP_GLUE_5E24,
    OP_GLUE_5E28, OP_GLUE_5E28, OP_GLUE_5E28, OP_GLUE_5E28,
    OP_GLUE_5E28, OP_GLUE_5E28, OP_GLUE_5E28, OP_GLUE_5E28,

    // 0101 1110 0011 0000
    OP_GLUE_5E30, OP_GLUE_5E30, OP_GLUE_5E30, OP_GLUE_5E30,
    OP_GLUE_5E30, OP_GLUE_5E30, OP_GLUE_5E30, OP_GLUE_5E30,
    OP_GLUE_5E30, OP_GLUE_5E30, OP_GLUE_5E30, OP_GLUE_5E30,
    OP_GLUE_5E30, OP_GLUE_5E30, OP_GLUE_5E30, OP_GLUE_5E30,

    // 0101 1110 0100 0000
    OP_GLUE_5E40, OP_GLUE_5E40, OP_GLUE_5E40, OP_GLUE_5E40,
    OP_GLUE_5E40, OP_GLUE_5E40, OP_GLUE_5E40, OP_GLUE_5E40,
    OP_GLUE_5E40, OP_GLUE_5E40, OP_GLUE_5E40, OP_GLUE_5E40,
    OP_GLUE_5E40, OP_GLUE_5E40, OP_GLUE_5E40, OP_GLUE_5E40,

    // 0101 1110 0101 0000
    OP_GLUE_5E40, OP_GLUE_5E40, OP_GLUE_5E40, OP_GLUE_5E40,
    OP_GLUE_5E40, OP_GLUE_5E40, OP_GLUE_5E40, OP_GLUE_5E40,
    OP_GLUE_5E40, OP_GLUE_5E40, OP_GLUE_5E40, OP_GLUE_5E40,
    OP_GLUE_5E40, OP_GLUE_5E40, OP_GLUE_5E40, OP_GLUE_5E40,

    // 0101 1110 0110 0000
    OP_GLUE_5E60, OP_GLUE_5E60, OP_GLUE_5E60, OP_GLUE_5E60,
    OP_GLUE_5E60, OP_GLUE_5E60, OP_GLUE_5E60, OP_GLUE_5E60,
    OP_GLUE_5E60, OP_GLUE_5E60, OP_GLUE_5E60, OP_GLUE_5E60,
    OP_GLUE_5E60, OP_GLUE_5E60, OP_GLUE_5E60, OP_GLUE_5E60,

    // 0101 1110 0111 0000
    OP_GLUE_5E60, OP_GLUE_5E60, OP_GLUE_5E60, OP_GLUE_5E60,
    OP_GLUE_5E60, OP_GLUE_5E60, OP_GLUE_5E60, OP_GLUE_5E60,
    OP_GLUE_5E60, OP_GLUE_5E60, OP_GLUE_5E60, OP_GLUE_5E60,
    OP_GLUE_5E60, OP_GLUE_5E60, OP_GLUE_5E60, OP_GLUE_5E60,

    // 0101 1110 1000 0000
    OP_GLUE_5E80, OP_GLUE_5E80, OP_GLUE_5E80, OP_GLUE_5E80,
    OP_GLUE_5E80, OP_GLUE_5E80, OP_GLUE_5E80, OP_GLUE_5E80,
    OP_GLUE_5E80, OP_GLUE_5E80, OP_GLUE_5E80, OP_GLUE_5E80,
    OP_GLUE_5E80, OP_GLUE_5E80, OP_GLUE_5E80, OP_GLUE_5E80,

    // 0101 1110 1001 0000
    OP_GLUE_5E80, OP_GLUE_5E80, OP_GLUE_5E80, OP_GLUE_5E80,
    OP_GLUE_5E80, OP_GLUE_5E80, OP_GLUE_5E80, OP_GLUE_5E80,
    OP_GLUE_5E80, OP_GLUE_5E80, OP_GLUE_5E80, OP_GLUE_5E80,
    OP_GLUE_5E80, OP_GLUE_5E80, OP_GLUE_5E80, OP_GLUE_5E80,

    // 0101 1110 1010 0000
    OP_GLUE_5EA0, OP_GLUE_5EA0, OP_GLUE_5EA0, OP_GLUE_5EA0,
    OP_GLUE_5EA0, OP_GLUE_5EA0, OP_GLUE_5EA0, OP_GLUE_5EA0,
    OP_GLUE_5EA0, OP_GLUE_5EA0, OP_GLUE_5EA0, OP_GLUE_5EA0,
    OP_GLUE_5EA0, OP_GLUE_5EA0, OP_GLUE_5EA0, OP_GLUE_5EA0,

    // 0101 1110 1011 0000
    OP_GLUE_5EB0, OP_GLUE_5EB0, OP_GLUE_5EB0, OP_GLUE_5EB0,
    OP_UNDEFINED, OP_UNDEFINED, OP_UNDEFINED, OP_UNDEFINED,
    OP_GLUE_5EB8, OP_GLUE_5EB8, OP_GLUE_5EB8, OP_GLUE_5EB8,
    OP_GLUE_5EB8, OP_GLUE_5EB8, OP_GLUE_5EB8, OP_GLUE_5EB8,

    // 0101 1110 1100 0000
    OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0,
    OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0,
    OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0,
    OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0,

    // 0101 1110 1101 0000
    OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0,
    OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0,
    OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0,
    OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0,

    // 0101 1110 1110 0000
    OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0,
    OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0,
    OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0,
    OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0,

    // 0101 1110 1111 0000
    OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0,
    OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0,
    OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0,
    OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0, OP_GLUE_5EC0,

    // 0101 1111 0000 0000
    OP_GLUE_5F00, OP_GLUE_5F00, OP_GLUE_5F00, OP_GLUE_5F00,
    OP_GLUE_5F00, OP_GLUE_5F00, OP_GLUE_5F00, OP_GLUE_5F00,
    OP_GLUE_5F00, OP_GLUE_5F00, OP_GLUE_5F00, OP_GLUE_5F00,
    OP_GLUE_5F00, OP_GLUE_5F00, OP_GLUE_5F00, OP_GLUE_5F00,

    // 0101 1111 0001 0000
    OP_GLUE_5F00, OP_GLUE_5F00, OP_GLUE_5F00, OP_GLUE_5F00,
    OP_GLUE_5F00, OP_GLUE_5F00, OP_GLUE_5F00, OP_GLUE_5F00,
    OP_GLUE_5F00, OP_GLUE_5F00, OP_GLUE_5F00, OP_GLUE_5F00,
    OP_GLUE_5F00, OP_GLUE_5F00, OP_GLUE_5F00, OP_GLUE_5F00,

    // 0101 1111 0010 0000
    OP_GLUE_5E20, OP_GLUE_5E21, OP_GLUE_5E22, OP_GLUE_5E23,
    OP_GLUE_5F24, OP_GLUE_5F24, OP_GLUE_5F24, OP_GLUE_5F24,
    OP_GLUE_5E28, OP_GLUE_5E28, OP_GLUE_5E28, OP_GLUE_5E28,
    OP_GLUE_5E28, OP_GLUE_5E28, OP_GLUE_5E28, OP_GLUE_5E28,

    // 0101 1111 0011 0000
    OP_GLUE_5E30, OP_GLUE_5E30, OP_GLUE_5E30, OP_GLUE_5E30,
    OP_GLUE_5E30, OP_GLUE_5E30, OP_GLUE_5E30, OP_GLUE_5E30,
    OP_GLUE_5E30, OP_GLUE_5E30, OP_GLUE_5E30, OP_GLUE_5E30,
    OP_GLUE_5E30, OP_GLUE_5E30, OP_GLUE_5E30, OP_GLUE_5E30,

    // 0101 1111 0100 0000
    OP_GLUE_5F40, OP_GLUE_5F41, OP_GLUE_5F42, OP_GLUE_5F42,
    OP_UNDEFINED, OP_GLUE_5F45, OP_GLUE_5F46, OP_GLUE_5F47,
    OP_GLUE_5F48, OP_GLUE_5F48, OP_GLUE_5F48, OP_GLUE_5F48,
    OP_GLUE_5F4C, OP_GLUE_5F4C, OP_GLUE_5F4C, OP_GLUE_5F4C,

    // 0101 1111 0101 0000
    OP_GLUE_5F50, OP_GLUE_5F50, OP_GLUE_5F50, OP_GLUE_5F50,
    OP_GLUE_5F50, OP_GLUE_5F50, OP_GLUE_5F50, OP_GLUE_5F50,
    OP_GLUE_5F50, OP_GLUE_5F50, OP_GLUE_5F50, OP_GLUE_5F50,
    OP_GLUE_5F50, OP_GLUE_5F50, OP_GLUE_5F50, OP_GLUE_5F50,

    // 0101 1111 0110 0000
    OP_GLUE_5F60, OP_GLUE_5F60, OP_GLUE_5F60, OP_GLUE_5F60,
    OP_GLUE_5F60, OP_GLUE_5F60, OP_GLUE_5F60, OP_GLUE_5F60,
    OP_GLUE_5F60, OP_GLUE_5F60, OP_GLUE_5F60, OP_GLUE_5F60,
    OP_GLUE_5F60, OP_GLUE_5F60, OP_GLUE_5F60, OP_GLUE_5F60,

    // 0101 1111 0111 0000
    OP_GLUE_5F60, OP_GLUE_5F60, OP_GLUE_5F60, OP_GLUE_5F60,
    OP_GLUE_5F60, OP_GLUE_5F60, OP_GLUE_5F60, OP_GLUE_5F60,
    OP_GLUE_5F60, OP_GLUE_5F60, OP_GLUE_5F60, OP_GLUE_5F60,
    OP_GLUE_5F60, OP_GLUE_5F60, OP_GLUE_5F60, OP_GLUE_5F60,

    // 0101 1111 1000 0000
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,

    // 0101 1111 1001 0000
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,

    // 0101 1111 1010 0000
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,

    // 0101 1111 1011 0000
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,

    // 0101 1111 1100 0000
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,

    // 0101 1111 1101 0000
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,

    // 0101 1111 1110 0000
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,

    // 0101 1111 1111 0000
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,
    OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80, OP_GLUE_5F80,

    // 0110 0000 0000 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0000 0001 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0000 0010 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0000 0011 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0000 0100 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0000 0101 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0000 0110 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0000 0111 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0000 1000 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0000 1001 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0000 1010 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0000 1011 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0000 1100 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0000 1101 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0000 1110 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0000 1111 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0001 0000 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 0001 0001 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 0001 0010 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 0001 0011 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 0001 0100 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 0001 0101 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 0001 0110 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 0001 0111 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 0001 1000 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 0001 1001 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 0001 1010 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 0001 1011 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 0001 1100 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 0001 1101 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 0001 1110 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 0001 1111 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 0010 0000 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0010 0001 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0010 0010 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0010 0011 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0010 0100 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0010 0101 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0010 0110 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0010 0111 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0010 1000 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0010 1001 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0010 1010 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0010 1011 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0010 1100 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0010 1101 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0010 1110 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0010 1111 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0011 0000 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 0011 0001 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 0011 0010 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 0011 0011 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 0011 0100 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 0011 0101 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 0011 0110 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 0011 0111 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 0011 1000 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 0011 1001 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 0011 1010 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 0011 1011 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 0011 1100 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 0011 1101 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 0011 1110 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 0011 1111 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 0100 0000 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0100 0001 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0100 0010 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0100 0011 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0100 0100 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0100 0101 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0100 0110 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0100 0111 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0100 1000 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0100 1001 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0100 1010 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0100 1011 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0100 1100 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0100 1101 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0100 1110 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0100 1111 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 0101 0000 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0110 0101 0001 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0110 0101 0010 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0110 0101 0011 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0110 0101 0100 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0110 0101 0101 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0110 0101 0110 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0110 0101 0111 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0110 0101 1000 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0110 0101 1001 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0110 0101 1010 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0110 0101 1011 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0110 0101 1100 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0110 0101 1101 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0110 0101 1110 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0110 0101 1111 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0110 0110 0000 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0110 0001 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0110 0010 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0110 0011 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0110 0100 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0110 0101 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0110 0110 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0110 0111 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0110 1000 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0110 1001 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0110 1010 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0110 1011 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0110 1100 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0110 1101 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0110 1110 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0110 1111 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 0111 0000 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0110 0111 0001 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0110 0111 0010 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0110 0111 0011 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0110 0111 0100 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0110 0111 0101 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0110 0111 0110 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0110 0111 0111 0000
    OP_GLUE_6770, OP_GLUE_6770, OP_GLUE_6770, OP_GLUE_6770,
    OP_GLUE_6770, OP_GLUE_6770, OP_GLUE_6770, OP_GLUE_6770,
    OP_GLUE_6770, OP_GLUE_6770, OP_GLUE_6770, OP_GLUE_6770,
    OP_GLUE_6770, OP_GLUE_6770, OP_GLUE_6770, OP_GLUE_6770,

    // 0110 0111 1000 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0110 0111 1001 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0110 0111 1010 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0110 0111 1011 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0110 0111 1100 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0110 0111 1101 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0110 0111 1110 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0110 0111 1111 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0110 1000 0000 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1000 0001 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1000 0010 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1000 0011 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1000 0100 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1000 0101 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1000 0110 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1000 0111 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1000 1000 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1000 1001 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1000 1010 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1000 1011 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1000 1100 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1000 1101 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1000 1110 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1000 1111 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1001 0000 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 1001 0001 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 1001 0010 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 1001 0011 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 1001 0100 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 1001 0101 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 1001 0110 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 1001 0111 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 1001 1000 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 1001 1001 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 1001 1010 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 1001 1011 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 1001 1100 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 1001 1101 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 1001 1110 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 1001 1111 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0110 1010 0000 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1010 0001 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1010 0010 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1010 0011 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1010 0100 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1010 0101 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1010 0110 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1010 0111 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1010 1000 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1010 1001 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1010 1010 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1010 1011 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1010 1100 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1010 1101 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1010 1110 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1010 1111 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1011 0000 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 1011 0001 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 1011 0010 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 1011 0011 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 1011 0100 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 1011 0101 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 1011 0110 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 1011 0111 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 1011 1000 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 1011 1001 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 1011 1010 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 1011 1011 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 1011 1100 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 1011 1101 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 1011 1110 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 1011 1111 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0110 1100 0000 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1100 0001 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1100 0010 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1100 0011 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1100 0100 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1100 0101 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1100 0110 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1100 0111 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1100 1000 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1100 1001 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1100 1010 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1100 1011 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1100 1100 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1100 1101 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1100 1110 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1100 1111 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0110 1101 0000 0000
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,

    // 0110 1101 0001 0000
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,

    // 0110 1101 0010 0000
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,

    // 0110 1101 0011 0000
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,

    // 0110 1101 0100 0000
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,

    // 0110 1101 0101 0000
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,

    // 0110 1101 0110 0000
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,

    // 0110 1101 0111 0000
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,

    // 0110 1101 1000 0000
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,

    // 0110 1101 1001 0000
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,

    // 0110 1101 1010 0000
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,

    // 0110 1101 1011 0000
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,

    // 0110 1101 1100 0000
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,

    // 0110 1101 1101 0000
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,

    // 0110 1101 1110 0000
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,

    // 0110 1101 1111 0000
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,
    OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00, OP_GLUE_6D00,

    // 0110 1110 0000 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1110 0001 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1110 0010 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1110 0011 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1110 0100 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1110 0101 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1110 0110 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1110 0111 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1110 1000 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1110 1001 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1110 1010 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1110 1011 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1110 1100 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1110 1101 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1110 1110 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1110 1111 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0110 1111 0000 0000
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,

    // 0110 1111 0001 0000
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,

    // 0110 1111 0010 0000
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,

    // 0110 1111 0011 0000
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,

    // 0110 1111 0100 0000
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,

    // 0110 1111 0101 0000
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,

    // 0110 1111 0110 0000
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,

    // 0110 1111 0111 0000
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,

    // 0110 1111 1000 0000
    OP_GLUE_6F80, OP_GLUE_6F80, OP_GLUE_6F80, OP_GLUE_6F80,
    OP_GLUE_6F80, OP_GLUE_6F80, OP_GLUE_6F80, OP_GLUE_6F80,
    OP_GLUE_6F80, OP_GLUE_6F80, OP_GLUE_6F80, OP_GLUE_6F80,
    OP_GLUE_6F80, OP_GLUE_6F80, OP_GLUE_6F80, OP_GLUE_6F80,

    // 0110 1111 1001 0000
    OP_GLUE_6F80, OP_GLUE_6F80, OP_GLUE_6F80, OP_GLUE_6F80,
    OP_GLUE_6F80, OP_GLUE_6F80, OP_GLUE_6F80, OP_GLUE_6F80,
    OP_GLUE_6F80, OP_GLUE_6F80, OP_GLUE_6F80, OP_GLUE_6F80,
    OP_GLUE_6F80, OP_GLUE_6F80, OP_GLUE_6F80, OP_GLUE_6F80,

    // 0110 1111 1010 0000
    OP_GLUE_6FA0, OP_GLUE_6FA0, OP_GLUE_6FA0, OP_GLUE_6FA0,
    OP_GLUE_6FA0, OP_GLUE_6FA0, OP_GLUE_6FA0, OP_GLUE_6FA0,
    OP_GLUE_6FA0, OP_GLUE_6FA0, OP_GLUE_6FA0, OP_GLUE_6FA0,
    OP_GLUE_6FA0, OP_GLUE_6FA0, OP_GLUE_6FA0, OP_GLUE_6FA0,

    // 0110 1111 1011 0000
    OP_GLUE_6FA0, OP_GLUE_6FA0, OP_GLUE_6FA0, OP_GLUE_6FA0,
    OP_GLUE_6FA0, OP_GLUE_6FA0, OP_GLUE_6FA0, OP_GLUE_6FA0,
    OP_GLUE_6FA0, OP_GLUE_6FA0, OP_GLUE_6FA0, OP_GLUE_6FA0,
    OP_GLUE_6FA0, OP_GLUE_6FA0, OP_GLUE_6FA0, OP_GLUE_6FA0,

    // 0110 1111 1100 0000
    OP_GLUE_6FC0, OP_GLUE_6FC0, OP_GLUE_6FC0, OP_GLUE_6FC0,
    OP_GLUE_6FC0, OP_GLUE_6FC0, OP_GLUE_6FC0, OP_GLUE_6FC0,
    OP_GLUE_6FC0, OP_GLUE_6FC0, OP_GLUE_6FC0, OP_GLUE_6FC0,
    OP_GLUE_6FC0, OP_GLUE_6FC0, OP_GLUE_6FC0, OP_GLUE_6FC0,

    // 0110 1111 1101 0000
    OP_GLUE_6FC0, OP_GLUE_6FC0, OP_GLUE_6FC0, OP_GLUE_6FC0,
    OP_GLUE_6FC0, OP_GLUE_6FC0, OP_GLUE_6FC0, OP_GLUE_6FC0,
    OP_GLUE_6FC0, OP_GLUE_6FC0, OP_GLUE_6FC0, OP_GLUE_6FC0,
    OP_GLUE_6FC0, OP_GLUE_6FC0, OP_GLUE_6FC0, OP_GLUE_6FC0,

    // 0110 1111 1110 0000
    OP_GLUE_6FE0, OP_GLUE_6FE0, OP_GLUE_6FE0, OP_GLUE_6FE0,
    OP_GLUE_6FE0, OP_GLUE_6FE0, OP_GLUE_6FE0, OP_GLUE_6FE0,
    OP_GLUE_6FE0, OP_GLUE_6FE0, OP_GLUE_6FE0, OP_GLUE_6FE0,
    OP_GLUE_6FE0, OP_GLUE_6FE0, OP_GLUE_6FE0, OP_GLUE_6FE0,

    // 0110 1111 1111 0000
    OP_GLUE_6FE0, OP_GLUE_6FE0, OP_GLUE_6FE0, OP_GLUE_6FE0,
    OP_GLUE_6FE0, OP_GLUE_6FE0, OP_GLUE_6FE0, OP_GLUE_6FE0,
    OP_GLUE_6FE0, OP_GLUE_6FE0, OP_GLUE_6FE0, OP_GLUE_6FE0,
    OP_GLUE_6FE0, OP_GLUE_6FE0, OP_GLUE_6FE0, OP_GLUE_6FE0,

    // 0111 0000 0000 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0000 0001 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0000 0010 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0000 0011 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0000 0100 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0000 0101 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0000 0110 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0000 0111 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0000 1000 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0000 1001 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0000 1010 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0000 1011 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0000 1100 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0000 1101 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0000 1110 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0000 1111 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0001 0000 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 0001 0001 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 0001 0010 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 0001 0011 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 0001 0100 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 0001 0101 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 0001 0110 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 0001 0111 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 0001 1000 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 0001 1001 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 0001 1010 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 0001 1011 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 0001 1100 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 0001 1101 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 0001 1110 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 0001 1111 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 0010 0000 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0010 0001 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0010 0010 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0010 0011 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0010 0100 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0010 0101 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0010 0110 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0010 0111 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0010 1000 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0010 1001 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0010 1010 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0010 1011 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0010 1100 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0010 1101 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0010 1110 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0010 1111 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0011 0000 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 0011 0001 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 0011 0010 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 0011 0011 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 0011 0100 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 0011 0101 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 0011 0110 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 0011 0111 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 0011 1000 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 0011 1001 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 0011 1010 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 0011 1011 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 0011 1100 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 0011 1101 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 0011 1110 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 0011 1111 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 0100 0000 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0100 0001 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0100 0010 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0100 0011 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0100 0100 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0100 0101 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0100 0110 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0100 0111 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0100 1000 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0100 1001 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0100 1010 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0100 1011 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0100 1100 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0100 1101 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0100 1110 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0100 1111 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 0101 0000 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0111 0101 0001 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0111 0101 0010 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0111 0101 0011 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0111 0101 0100 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0111 0101 0101 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0111 0101 0110 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0111 0101 0111 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0111 0101 1000 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0111 0101 1001 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0111 0101 1010 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0111 0101 1011 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0111 0101 1100 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0111 0101 1101 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0111 0101 1110 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0111 0101 1111 0000
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,
    OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500, OP_GLUE_6500,

    // 0111 0110 0000 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0110 0001 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0110 0010 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0110 0011 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0110 0100 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0110 0101 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0110 0110 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0110 0111 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0110 1000 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0110 1001 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0110 1010 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0110 1011 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0110 1100 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0110 1101 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0110 1110 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0110 1111 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 0111 0000 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0111 0111 0001 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0111 0111 0010 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0111 0111 0011 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0111 0111 0100 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0111 0111 0101 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0111 0111 0110 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0111 0111 0111 0000
    OP_GLUE_6770, OP_GLUE_6770, OP_GLUE_6770, OP_GLUE_6770,
    OP_GLUE_6770, OP_GLUE_6770, OP_GLUE_6770, OP_GLUE_6770,
    OP_GLUE_6770, OP_GLUE_6770, OP_GLUE_6770, OP_GLUE_6770,
    OP_GLUE_6770, OP_GLUE_6770, OP_GLUE_6770, OP_GLUE_6770,

    // 0111 0111 1000 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0111 0111 1001 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0111 0111 1010 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0111 0111 1011 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0111 0111 1100 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0111 0111 1101 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0111 0111 1110 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0111 0111 1111 0000
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,
    OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700, OP_GLUE_6700,

    // 0111 1000 0000 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1000 0001 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1000 0010 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1000 0011 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1000 0100 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1000 0101 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1000 0110 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1000 0111 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1000 1000 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1000 1001 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1000 1010 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1000 1011 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1000 1100 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1000 1101 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1000 1110 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1000 1111 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1001 0000 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 1001 0001 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 1001 0010 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 1001 0011 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 1001 0100 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 1001 0101 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 1001 0110 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 1001 0111 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 1001 1000 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 1001 1001 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 1001 1010 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 1001 1011 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 1001 1100 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 1001 1101 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 1001 1110 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 1001 1111 0000
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,
    OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100, OP_GLUE_6100,

    // 0111 1010 0000 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1010 0001 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1010 0010 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1010 0011 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1010 0100 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1010 0101 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1010 0110 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1010 0111 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1010 1000 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1010 1001 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1010 1010 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1010 1011 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1010 1100 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1010 1101 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1010 1110 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1010 1111 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1011 0000 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 1011 0001 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 1011 0010 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 1011 0011 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 1011 0100 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 1011 0101 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 1011 0110 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 1011 0111 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 1011 1000 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 1011 1001 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 1011 1010 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 1011 1011 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 1011 1100 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 1011 1101 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 1011 1110 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 1011 1111 0000
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,
    OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300, OP_GLUE_6300,

    // 0111 1100 0000 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1100 0001 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1100 0010 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1100 0011 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1100 0100 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1100 0101 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1100 0110 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1100 0111 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1100 1000 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1100 1001 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1100 1010 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1100 1011 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1100 1100 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1100 1101 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1100 1110 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1100 1111 0000
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,
    OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000, OP_GLUE_6000,

    // 0111 1101 0000 0000
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,

    // 0111 1101 0001 0000
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,

    // 0111 1101 0010 0000
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,

    // 0111 1101 0011 0000
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,

    // 0111 1101 0100 0000
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,

    // 0111 1101 0101 0000
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,

    // 0111 1101 0110 0000
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,

    // 0111 1101 0111 0000
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,

    // 0111 1101 1000 0000
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,

    // 0111 1101 1001 0000
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,

    // 0111 1101 1010 0000
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,

    // 0111 1101 1011 0000
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,

    // 0111 1101 1100 0000
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,

    // 0111 1101 1101 0000
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,

    // 0111 1101 1110 0000
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,

    // 0111 1101 1111 0000
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,
    OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00, OP_GLUE_7D00,

    // 0111 1110 0000 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1110 0001 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1110 0010 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1110 0011 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1110 0100 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1110 0101 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1110 0110 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1110 0111 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1110 1000 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1110 1001 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1110 1010 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1110 1011 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1110 1100 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1110 1101 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1110 1110 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1110 1111 0000
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,
    OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200, OP_GLUE_6200,

    // 0111 1111 0000 0000
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,

    // 0111 1111 0001 0000
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,

    // 0111 1111 0010 0000
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,

    // 0111 1111 0011 0000
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,

    // 0111 1111 0100 0000
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,

    // 0111 1111 0101 0000
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,

    // 0111 1111 0110 0000
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,

    // 0111 1111 0111 0000
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,
    OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00, OP_GLUE_6F00,

    // 0111 1111 1000 0000
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,

    // 0111 1111 1001 0000
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,

    // 0111 1111 1010 0000
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,

    // 0111 1111 1011 0000
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,

    // 0111 1111 1100 0000
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,

    // 0111 1111 1101 0000
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,

    // 0111 1111 1110 0000
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,

    // 0111 1111 1111 0000
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,
    OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80, OP_GLUE_7F80,

    // 1000 0000 0000 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 0000 0001 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 0000 0010 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 0000 0011 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 0000 0100 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 0000 0101 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 0000 0110 0000
    OP_GLUE_8060, OP_GLUE_8061, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8064, OP_GLUE_8064, OP_GLUE_8064, OP_GLUE_8064,
    OP_GLUE_8060, OP_GLUE_8069, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8064, OP_GLUE_8064, OP_GLUE_8064, OP_GLUE_8064,

    // 1000 0000 0111 0000
    OP_GLUE_8060, OP_GLUE_8071, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8064, OP_GLUE_8064, OP_GLUE_8064, OP_GLUE_8064,
    OP_GLUE_8060, OP_GLUE_8079, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8064, OP_GLUE_8064, OP_GLUE_8064, OP_GLUE_8064,

    // 1000 0000 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 0000 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 0000 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 0000 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 0000 1100 0000
    OP_GLUE_80C0, OP_GLUE_80C1, OP_GLUE_80C2, OP_GLUE_80C2,
    OP_GLUE_80C4, OP_GLUE_80C4, OP_GLUE_80C6, OP_GLUE_80C7,
    OP_GLUE_80C8, OP_GLUE_80C8, OP_GLUE_80C8, OP_GLUE_80C8,
    OP_GLUE_80C8, OP_GLUE_80C8, OP_GLUE_80C8, OP_GLUE_80C8,

    // 1000 0000 1101 0000
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,

    // 1000 0000 1110 0000
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,

    // 1000 0000 1111 0000
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,

    // 1000 0001 0000 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 0001 0001 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 0001 0010 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 0001 0011 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 0001 0100 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 0001 0101 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 0001 0110 0000
    OP_GLUE_8060, OP_GLUE_8061, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8064, OP_GLUE_8064, OP_GLUE_8064, OP_GLUE_8064,
    OP_GLUE_8060, OP_GLUE_8069, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8064, OP_GLUE_8064, OP_GLUE_8064, OP_GLUE_8064,

    // 1000 0001 0111 0000
    OP_GLUE_8060, OP_GLUE_8071, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8064, OP_GLUE_8064, OP_GLUE_8064, OP_GLUE_8064,
    OP_GLUE_8060, OP_GLUE_8079, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8064, OP_GLUE_8064, OP_GLUE_8064, OP_GLUE_8064,

    // 1000 0001 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 0001 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 0001 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 0001 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 0001 1100 0000
    OP_GLUE_80C0, OP_GLUE_80C1, OP_GLUE_80C2, OP_GLUE_80C2,
    OP_GLUE_80C4, OP_GLUE_80C4, OP_UNDEFINED, OP_GLUE_80C7,
    OP_GLUE_81C8, OP_GLUE_81C8, OP_GLUE_81C8, OP_GLUE_81C8,
    OP_GLUE_81C8, OP_GLUE_81C8, OP_GLUE_81C8, OP_GLUE_81C8,

    // 1000 0001 1101 0000
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,

    // 1000 0001 1110 0000
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,

    // 1000 0001 1111 0000
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,

    // 1000 0010 0000 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 0010 0001 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 0010 0010 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 0010 0011 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 0010 0100 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 0010 0101 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 0010 0110 0000
    OP_GLUE_8260, OP_GLUE_8061, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8264, OP_GLUE_8264, OP_GLUE_8264, OP_GLUE_8264,
    OP_GLUE_8260, OP_GLUE_8069, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8264, OP_GLUE_8264, OP_GLUE_8264, OP_GLUE_8264,

    // 1000 0010 0111 0000
    OP_GLUE_8260, OP_GLUE_8071, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8264, OP_GLUE_8264, OP_GLUE_8264, OP_GLUE_8264,
    OP_GLUE_8260, OP_GLUE_8079, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8264, OP_GLUE_8264, OP_GLUE_8264, OP_GLUE_8264,

    // 1000 0010 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 0010 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 0010 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 0010 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 0010 1100 0000
    OP_GLUE_80C0, OP_GLUE_80C1, OP_GLUE_80C2, OP_GLUE_80C2,
    OP_GLUE_80C4, OP_GLUE_80C4, OP_GLUE_82C6, OP_GLUE_80C7,
    OP_GLUE_82C8, OP_GLUE_82C8, OP_GLUE_82C8, OP_GLUE_82C8,
    OP_GLUE_82C8, OP_GLUE_82C8, OP_GLUE_82C8, OP_GLUE_82C8,

    // 1000 0010 1101 0000
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,

    // 1000 0010 1110 0000
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,

    // 1000 0010 1111 0000
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,

    // 1000 0011 0000 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 0011 0001 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 0011 0010 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 0011 0011 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 0011 0100 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 0011 0101 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 0011 0110 0000
    OP_GLUE_8260, OP_GLUE_8061, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8264, OP_GLUE_8264, OP_GLUE_8264, OP_GLUE_8264,
    OP_GLUE_8260, OP_GLUE_8069, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8264, OP_GLUE_8264, OP_GLUE_8264, OP_GLUE_8264,

    // 1000 0011 0111 0000
    OP_GLUE_8260, OP_GLUE_8071, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8264, OP_GLUE_8264, OP_GLUE_8264, OP_GLUE_8264,
    OP_GLUE_8260, OP_GLUE_8079, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8264, OP_GLUE_8264, OP_GLUE_8264, OP_GLUE_8264,

    // 1000 0011 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 0011 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 0011 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 0011 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 0011 1100 0000
    OP_GLUE_80C0, OP_GLUE_80C1, OP_GLUE_80C2, OP_GLUE_80C2,
    OP_GLUE_80C4, OP_GLUE_80C4, OP_GLUE_83C6, OP_GLUE_80C7,
    OP_GLUE_83C8, OP_GLUE_83C8, OP_GLUE_83C8, OP_GLUE_83C8,
    OP_GLUE_83C8, OP_GLUE_83C8, OP_GLUE_83C8, OP_GLUE_83C8,

    // 1000 0011 1101 0000
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,

    // 1000 0011 1110 0000
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,

    // 1000 0011 1111 0000
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,

    // 1000 0100 0000 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 0100 0001 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 0100 0010 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 0100 0011 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 0100 0100 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 0100 0101 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 0100 0110 0000
    OP_GLUE_8460, OP_GLUE_8461, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464,
    OP_GLUE_8460, OP_GLUE_8469, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464,

    // 1000 0100 0111 0000
    OP_GLUE_8460, OP_GLUE_8471, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464,
    OP_GLUE_8460, OP_GLUE_8479, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464,

    // 1000 0100 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 0100 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 0100 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 0100 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 0100 1100 0000
    OP_GLUE_80C0, OP_GLUE_80C1, OP_GLUE_80C2, OP_GLUE_80C2,
    OP_GLUE_80C4, OP_GLUE_80C4, OP_GLUE_80C6, OP_GLUE_80C7,
    OP_GLUE_80C8, OP_GLUE_80C8, OP_GLUE_80C8, OP_GLUE_80C8,
    OP_GLUE_80C8, OP_GLUE_80C8, OP_GLUE_80C8, OP_GLUE_80C8,

    // 1000 0100 1101 0000
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,

    // 1000 0100 1110 0000
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,

    // 1000 0100 1111 0000
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,

    // 1000 0101 0000 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 0101 0001 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 0101 0010 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 0101 0011 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 0101 0100 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 0101 0101 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 0101 0110 0000
    OP_GLUE_8460, OP_GLUE_8461, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464,
    OP_GLUE_8460, OP_GLUE_8469, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464,

    // 1000 0101 0111 0000
    OP_GLUE_8460, OP_GLUE_8471, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464,
    OP_GLUE_8460, OP_GLUE_8479, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464,

    // 1000 0101 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 0101 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 0101 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 0101 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 0101 1100 0000
    OP_GLUE_80C0, OP_GLUE_80C1, OP_GLUE_80C2, OP_GLUE_80C2,
    OP_GLUE_80C4, OP_GLUE_80C4, OP_UNDEFINED, OP_GLUE_80C7,
    OP_GLUE_81C8, OP_GLUE_81C8, OP_GLUE_81C8, OP_GLUE_81C8,
    OP_GLUE_81C8, OP_GLUE_81C8, OP_GLUE_81C8, OP_GLUE_81C8,

    // 1000 0101 1101 0000
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,

    // 1000 0101 1110 0000
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,

    // 1000 0101 1111 0000
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,

    // 1000 0110 0000 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 0110 0001 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 0110 0010 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 0110 0011 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 0110 0100 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 0110 0101 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 0110 0110 0000
    OP_GLUE_8660, OP_GLUE_8461, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464,
    OP_GLUE_8660, OP_GLUE_8469, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464,

    // 1000 0110 0111 0000
    OP_GLUE_8660, OP_GLUE_8471, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464,
    OP_GLUE_8660, OP_GLUE_8479, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464,

    // 1000 0110 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 0110 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 0110 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 0110 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 0110 1100 0000
    OP_GLUE_80C0, OP_GLUE_80C1, OP_GLUE_80C2, OP_GLUE_80C2,
    OP_GLUE_80C4, OP_GLUE_80C4, OP_GLUE_82C6, OP_GLUE_80C7,
    OP_GLUE_82C8, OP_GLUE_82C8, OP_GLUE_82C8, OP_GLUE_82C8,
    OP_GLUE_82C8, OP_GLUE_82C8, OP_GLUE_82C8, OP_GLUE_82C8,

    // 1000 0110 1101 0000
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,

    // 1000 0110 1110 0000
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,

    // 1000 0110 1111 0000
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,

    // 1000 0111 0000 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 0111 0001 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 0111 0010 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 0111 0011 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 0111 0100 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 0111 0101 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 0111 0110 0000
    OP_GLUE_8660, OP_GLUE_8461, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464,
    OP_GLUE_8660, OP_GLUE_8469, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464,

    // 1000 0111 0111 0000
    OP_GLUE_8660, OP_GLUE_8471, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464,
    OP_GLUE_8660, OP_GLUE_8479, OP_GLUE_8062, OP_GLUE_8063,
    OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464, OP_GLUE_8464,

    // 1000 0111 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 0111 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 0111 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 0111 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 0111 1100 0000
    OP_GLUE_80C0, OP_GLUE_80C1, OP_GLUE_80C2, OP_GLUE_80C2,
    OP_GLUE_80C4, OP_GLUE_80C4, OP_GLUE_83C6, OP_GLUE_80C7,
    OP_GLUE_83C8, OP_GLUE_83C8, OP_GLUE_83C8, OP_GLUE_83C8,
    OP_GLUE_83C8, OP_GLUE_83C8, OP_GLUE_83C8, OP_GLUE_83C8,

    // 1000 0111 1101 0000
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,
    OP_GLUE_80D0, OP_GLUE_80D1, OP_GLUE_80D2, OP_GLUE_80D3,

    // 1000 0111 1110 0000
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,

    // 1000 0111 1111 0000
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,

    // 1000 1000 0000 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 1000 0001 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 1000 0010 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 1000 0011 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 1000 0100 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 1000 0101 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 1000 0110 0000
    OP_GLUE_8860, OP_GLUE_8861, OP_GLUE_8862, OP_GLUE_8863,
    OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864,
    OP_GLUE_8860, OP_GLUE_8861, OP_GLUE_8862, OP_GLUE_886B,
    OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864,

    // 1000 1000 0111 0000
    OP_GLUE_8860, OP_GLUE_8861, OP_GLUE_8862, OP_GLUE_8873,
    OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864,
    OP_GLUE_8860, OP_GLUE_8861, OP_GLUE_8862, OP_GLUE_8873,
    OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864,

    // 1000 1000 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 1000 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 1000 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 1000 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 1000 1100 0000
    OP_UNDEFINED, OP_GLUE_80C1, OP_GLUE_80C2, OP_GLUE_80C2,
    OP_GLUE_80C4, OP_GLUE_80C4, OP_GLUE_80C6, OP_GLUE_80C7,
    OP_GLUE_80C8, OP_GLUE_80C8, OP_GLUE_80C8, OP_GLUE_80C8,
    OP_GLUE_80C8, OP_GLUE_80C8, OP_GLUE_80C8, OP_GLUE_80C8,

    // 1000 1000 1101 0000
    OP_GLUE_88D0, OP_GLUE_88D1, OP_GLUE_88D0, OP_GLUE_88D1,
    OP_GLUE_88D0, OP_GLUE_88D1, OP_GLUE_88D0, OP_GLUE_88D1,
    OP_GLUE_88D0, OP_GLUE_88D1, OP_GLUE_88D0, OP_GLUE_88D1,
    OP_GLUE_88D0, OP_GLUE_88D1, OP_GLUE_88D0, OP_GLUE_88D1,

    // 1000 1000 1110 0000
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,

    // 1000 1000 1111 0000
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,

    // 1000 1001 0000 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 1001 0001 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 1001 0010 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 1001 0011 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 1001 0100 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 1001 0101 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 1001 0110 0000
    OP_GLUE_8860, OP_GLUE_8961, OP_GLUE_8862, OP_GLUE_8863,
    OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864,
    OP_GLUE_8860, OP_GLUE_8961, OP_GLUE_8862, OP_GLUE_886B,
    OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864,

    // 1000 1001 0111 0000
    OP_GLUE_8860, OP_GLUE_8971, OP_GLUE_8862, OP_GLUE_8873,
    OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864,
    OP_GLUE_8860, OP_GLUE_8979, OP_GLUE_8862, OP_GLUE_8873,
    OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864,

    // 1000 1001 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 1001 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 1001 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 1001 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 1001 1100 0000
    OP_UNDEFINED, OP_GLUE_80C1, OP_GLUE_80C2, OP_GLUE_80C2,
    OP_GLUE_80C4, OP_GLUE_80C4, OP_UNDEFINED, OP_GLUE_80C7,
    OP_GLUE_81C8, OP_GLUE_81C8, OP_GLUE_81C8, OP_GLUE_81C8,
    OP_GLUE_81C8, OP_GLUE_81C8, OP_GLUE_81C8, OP_GLUE_81C8,

    // 1000 1001 1101 0000
    OP_GLUE_88D0, OP_GLUE_88D1, OP_GLUE_88D0, OP_GLUE_88D1,
    OP_GLUE_88D0, OP_GLUE_88D1, OP_GLUE_88D0, OP_GLUE_88D1,
    OP_GLUE_88D0, OP_GLUE_88D1, OP_GLUE_88D0, OP_GLUE_88D1,
    OP_GLUE_88D0, OP_GLUE_88D1, OP_GLUE_88D0, OP_GLUE_88D1,

    // 1000 1001 1110 0000
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,

    // 1000 1001 1111 0000
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,

    // 1000 1010 0000 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 1010 0001 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 1010 0010 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 1010 0011 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 1010 0100 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 1010 0101 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 1010 0110 0000
    OP_GLUE_8A60, OP_GLUE_8A61, OP_GLUE_8A62, OP_GLUE_8A63,
    OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864,
    OP_GLUE_8A60, OP_GLUE_8A61, OP_GLUE_8A62, OP_GLUE_8A63,
    OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864,

    // 1000 1010 0111 0000
    OP_GLUE_8A60, OP_GLUE_8A61, OP_GLUE_8A62, OP_GLUE_8A73,
    OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864,
    OP_GLUE_8A60, OP_GLUE_8A61, OP_GLUE_8A62, OP_GLUE_8A73,
    OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864,

    // 1000 1010 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 1010 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 1010 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 1010 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 1010 1100 0000
    OP_UNDEFINED, OP_GLUE_80C1, OP_GLUE_80C2, OP_GLUE_80C2,
    OP_GLUE_80C4, OP_GLUE_80C4, OP_GLUE_82C6, OP_GLUE_80C7,
    OP_GLUE_82C8, OP_GLUE_82C8, OP_GLUE_82C8, OP_GLUE_82C8,
    OP_GLUE_82C8, OP_GLUE_82C8, OP_GLUE_82C8, OP_GLUE_82C8,

    // 1000 1010 1101 0000
    OP_GLUE_88D0, OP_GLUE_88D1, OP_GLUE_88D0, OP_GLUE_88D1,
    OP_GLUE_88D0, OP_GLUE_88D1, OP_GLUE_88D0, OP_GLUE_88D1,
    OP_GLUE_88D0, OP_GLUE_88D1, OP_GLUE_88D0, OP_GLUE_88D1,
    OP_GLUE_88D0, OP_GLUE_88D1, OP_GLUE_88D0, OP_GLUE_88D1,

    // 1000 1010 1110 0000
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,

    // 1000 1010 1111 0000
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,

    // 1000 1011 0000 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 1011 0001 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 1011 0010 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 1011 0011 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 1011 0100 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 1011 0101 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 1011 0110 0000
    OP_GLUE_8A60, OP_GLUE_8A61, OP_GLUE_8A62, OP_GLUE_8B63,
    OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864,
    OP_GLUE_8A60, OP_GLUE_8A61, OP_GLUE_8A62, OP_UNDEFINED,
    OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864,

    // 1000 1011 0111 0000
    OP_GLUE_8A60, OP_GLUE_8A61, OP_GLUE_8A62, OP_GLUE_8B63,
    OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864,
    OP_GLUE_8A60, OP_GLUE_8A61, OP_GLUE_8A62, OP_UNDEFINED,
    OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864, OP_GLUE_8864,

    // 1000 1011 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 1011 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 1011 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 1011 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 1011 1100 0000
    OP_UNDEFINED, OP_GLUE_80C1, OP_GLUE_80C2, OP_GLUE_80C2,
    OP_GLUE_80C4, OP_GLUE_80C4, OP_GLUE_83C6, OP_GLUE_80C7,
    OP_GLUE_83C8, OP_GLUE_83C8, OP_GLUE_83C8, OP_GLUE_83C8,
    OP_GLUE_83C8, OP_GLUE_83C8, OP_GLUE_83C8, OP_GLUE_83C8,

    // 1000 1011 1101 0000
    OP_GLUE_88D0, OP_GLUE_88D1, OP_GLUE_88D0, OP_GLUE_88D1,
    OP_GLUE_88D0, OP_GLUE_88D1, OP_GLUE_88D0, OP_GLUE_88D1,
    OP_GLUE_88D0, OP_GLUE_88D1, OP_GLUE_88D0, OP_GLUE_88D1,
    OP_GLUE_88D0, OP_GLUE_88D1, OP_GLUE_88D0, OP_GLUE_88D1,

    // 1000 1011 1110 0000
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,

    // 1000 1011 1111 0000
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,

    // 1000 1100 0000 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 1100 0001 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 1100 0010 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 1100 0011 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 1100 0100 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 1100 0101 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 1100 0110 0000
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,

    // 1000 1100 0111 0000
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,

    // 1000 1100 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 1100 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 1100 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 1100 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 1100 1100 0000
    OP_GLUE_80C0, OP_GLUE_80C1, OP_GLUE_80C2, OP_GLUE_80C2,
    OP_GLUE_80C4, OP_GLUE_80C4, OP_GLUE_80C6, OP_GLUE_80C7,
    OP_GLUE_80C8, OP_GLUE_80C8, OP_GLUE_80C8, OP_GLUE_80C8,
    OP_GLUE_80C8, OP_GLUE_80C8, OP_GLUE_80C8, OP_GLUE_80C8,

    // 1000 1100 1101 0000
    OP_GLUE_8CD0, OP_GLUE_8CD0, OP_GLUE_8CD0, OP_GLUE_8CD0,
    OP_GLUE_8CD0, OP_GLUE_8CD0, OP_GLUE_8CD0, OP_GLUE_8CD0,
    OP_GLUE_8CD8, OP_GLUE_8CD8, OP_GLUE_8CD8, OP_GLUE_8CD8,
    OP_GLUE_8CDC, OP_GLUE_8CDC, OP_UNDEFINED, OP_GLUE_8CDF,

    // 1000 1100 1110 0000
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,

    // 1000 1100 1111 0000
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,

    // 1000 1101 0000 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 1101 0001 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 1101 0010 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 1101 0011 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 1101 0100 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 1101 0101 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 1101 0110 0000
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,

    // 1000 1101 0111 0000
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,

    // 1000 1101 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 1101 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 1101 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 1101 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 1101 1100 0000
    OP_GLUE_80C0, OP_GLUE_80C1, OP_GLUE_80C2, OP_GLUE_80C2,
    OP_GLUE_80C4, OP_GLUE_80C4, OP_UNDEFINED, OP_GLUE_80C7,
    OP_GLUE_81C8, OP_GLUE_81C8, OP_GLUE_81C8, OP_GLUE_81C8,
    OP_GLUE_81C8, OP_GLUE_81C8, OP_GLUE_81C8, OP_GLUE_81C8,

    // 1000 1101 1101 0000
    OP_GLUE_8DD0, OP_GLUE_8DD0, OP_GLUE_8DD0, OP_GLUE_8DD0,
    OP_GLUE_8DD0, OP_GLUE_8DD0, OP_GLUE_8DD0, OP_GLUE_8DD0,
    OP_GLUE_8DD0, OP_GLUE_8DD0, OP_GLUE_8DD0, OP_GLUE_8DD0,
    OP_GLUE_8DD0, OP_GLUE_8DD0, OP_GLUE_8DD0, OP_GLUE_8DD0,

    // 1000 1101 1110 0000
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,

    // 1000 1101 1111 0000
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,

    // 1000 1110 0000 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 1110 0001 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 1110 0010 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 1110 0011 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 1110 0100 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 1110 0101 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 1110 0110 0000
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,

    // 1000 1110 0111 0000
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,

    // 1000 1110 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 1110 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 1110 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 1110 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 1110 1100 0000
    OP_GLUE_80C0, OP_GLUE_80C1, OP_GLUE_80C2, OP_GLUE_80C2,
    OP_GLUE_80C4, OP_GLUE_80C4, OP_GLUE_82C6, OP_GLUE_80C7,
    OP_GLUE_82C8, OP_GLUE_82C8, OP_GLUE_82C8, OP_GLUE_82C8,
    OP_GLUE_82C8, OP_GLUE_82C8, OP_GLUE_82C8, OP_GLUE_82C8,

    // 1000 1110 1101 0000
    OP_GLUE_8ED0, OP_GLUE_8ED0, OP_GLUE_8ED0, OP_GLUE_8ED0,
    OP_GLUE_8ED0, OP_GLUE_8ED0, OP_GLUE_8ED0, OP_GLUE_8ED0,
    OP_GLUE_8ED0, OP_GLUE_8ED0, OP_GLUE_8ED0, OP_GLUE_8ED0,
    OP_GLUE_8ED0, OP_GLUE_8ED0, OP_GLUE_8ED0, OP_GLUE_8ED0,

    // 1000 1110 1110 0000
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,

    // 1000 1110 1111 0000
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,
    OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0, OP_GLUE_80E0,

    // 1000 1111 0000 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 1111 0001 0000
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,
    OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000, OP_GLUE_8000,

    // 1000 1111 0010 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 1111 0011 0000
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,
    OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020, OP_GLUE_8020,

    // 1000 1111 0100 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 1111 0101 0000
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,
    OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040, OP_GLUE_8040,

    // 1000 1111 0110 0000
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,

    // 1000 1111 0111 0000
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,
    OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60, OP_GLUE_8C60,

    // 1000 1111 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 1111 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1000 1111 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 1111 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1000 1111 1100 0000
    OP_GLUE_80C0, OP_GLUE_80C1, OP_GLUE_80C2, OP_GLUE_80C2,
    OP_GLUE_80C4, OP_GLUE_80C4, OP_GLUE_83C6, OP_GLUE_80C7,
    OP_GLUE_83C8, OP_GLUE_83C8, OP_GLUE_83C8, OP_GLUE_83C8,
    OP_GLUE_83C8, OP_GLUE_83C8, OP_GLUE_83C8, OP_GLUE_83C8,

    // 1000 1111 1101 0000
    OP_GLUE_8FD0, OP_GLUE_8FD0, OP_GLUE_8FD0, OP_GLUE_8FD0,
    OP_GLUE_8FD4, OP_GLUE_8FD4, OP_GLUE_8FD4, OP_GLUE_8FD4,
    OP_GLUE_8FD8, OP_GLUE_8FD8, OP_GLUE_8FD8, OP_GLUE_8FD8,
    OP_GLUE_8FDC, OP_GLUE_8FDC, OP_GLUE_8FDC, OP_GLUE_8FDC,

    // 1000 1111 1110 0000
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,

    // 1000 1111 1111 0000
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,
    OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0, OP_GLUE_81E0,

    // 1001 0000 0000 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 0000 0001 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9018, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 0000 0010 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 0000 0011 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 0000 0100 0000
    OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040,
    OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040,
    OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040,
    OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040,

    // 1001 0000 0101 0000
    OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040,
    OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040,
    OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040,
    OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040,

    // 1001 0000 0110 0000
    OP_GLUE_9060, OP_GLUE_9060, OP_GLUE_9062, OP_GLUE_9062,
    OP_GLUE_9064, OP_GLUE_9064, OP_GLUE_9064, OP_GLUE_9064,
    OP_GLUE_9068, OP_GLUE_9068, OP_UNDEFINED, OP_UNDEFINED,
    OP_GLUE_906C, OP_GLUE_906C, OP_GLUE_906C, OP_GLUE_906C,

    // 1001 0000 0111 0000
    OP_GLUE_9070, OP_GLUE_9070, OP_GLUE_9070, OP_GLUE_9070,
    OP_GLUE_9070, OP_GLUE_9070, OP_GLUE_9070, OP_GLUE_9070,
    OP_GLUE_9070, OP_GLUE_9070, OP_GLUE_9070, OP_GLUE_9070,
    OP_GLUE_9070, OP_GLUE_9070, OP_GLUE_9070, OP_GLUE_9070,

    // 1001 0000 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 0000 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 0000 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 0000 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 0000 1100 0000
    OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0,
    OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0,
    OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0,
    OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0,

    // 1001 0000 1101 0000
    OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0,
    OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0,
    OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0,
    OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0,

    // 1001 0000 1110 0000
    OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0,
    OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0,
    OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0,
    OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0,

    // 1001 0000 1111 0000
    OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0,
    OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0,
    OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0,
    OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0,

    // 1001 0001 0000 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 0001 0001 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9018, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 0001 0010 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 0001 0011 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 0001 0100 0000
    OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040,
    OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040,
    OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040,
    OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040,

    // 1001 0001 0101 0000
    OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040,
    OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040,
    OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040,
    OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040, OP_GLUE_9040,

    // 1001 0001 0110 0000
    OP_GLUE_9060, OP_GLUE_9060, OP_GLUE_9062, OP_GLUE_9062,
    OP_GLUE_9164, OP_GLUE_9164, OP_GLUE_9164, OP_GLUE_9164,
    OP_GLUE_9068, OP_GLUE_9068, OP_UNDEFINED, OP_UNDEFINED,
    OP_GLUE_916C, OP_GLUE_916C, OP_GLUE_916C, OP_GLUE_916C,

    // 1001 0001 0111 0000
    OP_GLUE_9070, OP_GLUE_9070, OP_GLUE_9070, OP_GLUE_9070,
    OP_GLUE_9070, OP_GLUE_9070, OP_GLUE_9070, OP_GLUE_9070,
    OP_GLUE_9070, OP_GLUE_9070, OP_GLUE_9070, OP_GLUE_9070,
    OP_GLUE_9070, OP_GLUE_9070, OP_GLUE_9070, OP_GLUE_9070,

    // 1001 0001 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 0001 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 0001 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 0001 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 0001 1100 0000
    OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0,
    OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0,
    OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0,
    OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0,

    // 1001 0001 1101 0000
    OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0,
    OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0,
    OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0,
    OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0, OP_GLUE_90C0,

    // 1001 0001 1110 0000
    OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0,
    OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0,
    OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0,
    OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0,

    // 1001 0001 1111 0000
    OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0,
    OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0,
    OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0,
    OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0, OP_GLUE_90E0,

    // 1001 0010 0000 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 0010 0001 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9018, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 0010 0010 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 0010 0011 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 0010 0100 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0010 0101 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0010 0110 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0010 0111 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0010 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 0010 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 0010 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 0010 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 0010 1100 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0010 1101 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0010 1110 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0010 1111 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0011 0000 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 0011 0001 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9018, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 0011 0010 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 0011 0011 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 0011 0100 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0011 0101 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0011 0110 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0011 0111 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0011 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 0011 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 0011 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 0011 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 0011 1100 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0011 1101 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0011 1110 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0011 1111 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0100 0000 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 0100 0001 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9018, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 0100 0010 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 0100 0011 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 0100 0100 0000
    OP_GLUE_9440, OP_GLUE_9440, OP_GLUE_9440, OP_GLUE_9440,
    OP_GLUE_9440, OP_GLUE_9440, OP_GLUE_9440, OP_GLUE_9440,
    OP_GLUE_9440, OP_GLUE_9440, OP_GLUE_9440, OP_GLUE_9440,
    OP_GLUE_9440, OP_GLUE_9440, OP_GLUE_9440, OP_GLUE_9440,

    // 1001 0100 0101 0000
    OP_GLUE_9440, OP_GLUE_9440, OP_GLUE_9440, OP_GLUE_9440,
    OP_GLUE_9440, OP_GLUE_9440, OP_GLUE_9440, OP_GLUE_9440,
    OP_GLUE_9440, OP_GLUE_9440, OP_GLUE_9440, OP_GLUE_9440,
    OP_GLUE_9440, OP_GLUE_9440, OP_GLUE_9440, OP_GLUE_9440,

    // 1001 0100 0110 0000
    OP_GLUE_9460, OP_GLUE_9460, OP_GLUE_9462, OP_GLUE_9462,
    OP_GLUE_9464, OP_GLUE_9464, OP_GLUE_9466, OP_GLUE_9466,
    OP_GLUE_9468, OP_GLUE_9468, OP_GLUE_9468, OP_GLUE_9468,
    OP_GLUE_9468, OP_GLUE_9468, OP_GLUE_9468, OP_GLUE_9468,

    // 1001 0100 0111 0000
    OP_GLUE_9470, OP_GLUE_9470, OP_GLUE_9470, OP_GLUE_9470,
    OP_GLUE_9470, OP_GLUE_9470, OP_GLUE_9470, OP_GLUE_9470,
    OP_GLUE_9478, OP_GLUE_9478, OP_GLUE_9478, OP_GLUE_9478,
    OP_GLUE_9478, OP_GLUE_9478, OP_GLUE_9478, OP_GLUE_9478,

    // 1001 0100 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 0100 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 0100 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 0100 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 0100 1100 0000
    OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0,
    OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0,
    OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0,
    OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0,

    // 1001 0100 1101 0000
    OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0,
    OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0,
    OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0,
    OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0,

    // 1001 0100 1110 0000
    OP_GLUE_94E0, OP_GLUE_94E1, OP_GLUE_94E2, OP_GLUE_94E3,
    OP_GLUE_94E4, OP_GLUE_94E5, OP_GLUE_94E6, OP_GLUE_94E7,
    OP_GLUE_94E0, OP_GLUE_94E1, OP_GLUE_94E2, OP_GLUE_94E3,
    OP_GLUE_94E4, OP_GLUE_94E5, OP_GLUE_94E6, OP_GLUE_94E7,

    // 1001 0100 1111 0000
    OP_GLUE_94E0, OP_GLUE_94E1, OP_GLUE_94E2, OP_GLUE_94E3,
    OP_GLUE_94E4, OP_GLUE_94E5, OP_GLUE_94E6, OP_GLUE_94E7,
    OP_GLUE_94E0, OP_GLUE_94E1, OP_GLUE_94E2, OP_GLUE_94E3,
    OP_GLUE_94E4, OP_GLUE_94E5, OP_GLUE_94E6, OP_GLUE_94E7,

    // 1001 0101 0000 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 0101 0001 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9018, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 0101 0010 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 0101 0011 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 0101 0100 0000
    OP_GLUE_9540, OP_GLUE_9540, OP_GLUE_9540, OP_GLUE_9540,
    OP_GLUE_9540, OP_GLUE_9540, OP_GLUE_9540, OP_GLUE_9540,
    OP_GLUE_9540, OP_GLUE_9540, OP_GLUE_9540, OP_GLUE_9540,
    OP_GLUE_9540, OP_GLUE_9540, OP_GLUE_9540, OP_GLUE_9540,

    // 1001 0101 0101 0000
    OP_GLUE_9540, OP_GLUE_9540, OP_GLUE_9540, OP_GLUE_9540,
    OP_GLUE_9540, OP_GLUE_9540, OP_GLUE_9540, OP_GLUE_9540,
    OP_GLUE_9540, OP_GLUE_9540, OP_GLUE_9540, OP_GLUE_9540,
    OP_GLUE_9540, OP_GLUE_9540, OP_GLUE_9540, OP_GLUE_9540,

    // 1001 0101 0110 0000
    OP_GLUE_9560, OP_GLUE_9560, OP_GLUE_9560, OP_GLUE_9560,
    OP_GLUE_9560, OP_GLUE_9560, OP_GLUE_9560, OP_GLUE_9560,
    OP_GLUE_9560, OP_GLUE_9560, OP_GLUE_9560, OP_GLUE_9560,
    OP_GLUE_9560, OP_GLUE_9560, OP_GLUE_9560, OP_GLUE_9560,

    // 1001 0101 0111 0000
    OP_GLUE_9560, OP_GLUE_9560, OP_GLUE_9560, OP_GLUE_9560,
    OP_GLUE_9560, OP_GLUE_9560, OP_GLUE_9560, OP_GLUE_9560,
    OP_GLUE_9560, OP_GLUE_9560, OP_GLUE_9560, OP_GLUE_9560,
    OP_GLUE_9560, OP_GLUE_9560, OP_GLUE_9560, OP_GLUE_9560,

    // 1001 0101 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 0101 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 0101 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 0101 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 0101 1100 0000
    OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0,
    OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0,
    OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0,
    OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0,

    // 1001 0101 1101 0000
    OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0,
    OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0,
    OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0,
    OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0, OP_GLUE_94C0,

    // 1001 0101 1110 0000
    OP_GLUE_94E0, OP_GLUE_94E1, OP_GLUE_94E2, OP_GLUE_94E3,
    OP_GLUE_94E4, OP_GLUE_94E5, OP_GLUE_94E6, OP_GLUE_94E7,
    OP_GLUE_94E0, OP_GLUE_94E1, OP_GLUE_94E2, OP_GLUE_94E3,
    OP_GLUE_94E4, OP_GLUE_94E5, OP_GLUE_94E6, OP_GLUE_94E7,

    // 1001 0101 1111 0000
    OP_GLUE_94E0, OP_GLUE_94E1, OP_GLUE_94E2, OP_GLUE_94E3,
    OP_GLUE_94E4, OP_GLUE_94E5, OP_GLUE_94E6, OP_GLUE_94E7,
    OP_GLUE_94E0, OP_GLUE_94E1, OP_GLUE_94E2, OP_GLUE_94E3,
    OP_GLUE_94E4, OP_GLUE_94E5, OP_GLUE_94E6, OP_GLUE_94E7,

    // 1001 0110 0000 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 0110 0001 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9018, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 0110 0010 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 0110 0011 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 0110 0100 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0110 0101 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0110 0110 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0110 0111 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0110 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 0110 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 0110 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 0110 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 0110 1100 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0110 1101 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0110 1110 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0110 1111 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0111 0000 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 0111 0001 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9018, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 0111 0010 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 0111 0011 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 0111 0100 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0111 0101 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0111 0110 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0111 0111 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0111 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 0111 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 0111 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 0111 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 0111 1100 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0111 1101 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0111 1110 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 0111 1111 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1000 0000 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 1000 0001 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9018, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 1000 0010 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 1000 0011 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 1000 0100 0000
    OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840,
    OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840,
    OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840,
    OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840,

    // 1001 1000 0101 0000
    OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840,
    OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840,
    OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840,
    OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840,

    // 1001 1000 0110 0000
    OP_GLUE_9860, OP_GLUE_9861, OP_GLUE_9862, OP_GLUE_9863,
    OP_GLUE_9860, OP_GLUE_9861, OP_GLUE_9862, OP_GLUE_9863,
    OP_GLUE_9860, OP_GLUE_9861, OP_GLUE_9862, OP_GLUE_9863,
    OP_GLUE_9860, OP_GLUE_9861, OP_GLUE_9862, OP_GLUE_9863,

    // 1001 1000 0111 0000
    OP_GLUE_9860, OP_GLUE_9861, OP_GLUE_9862, OP_GLUE_9863,
    OP_GLUE_9860, OP_GLUE_9861, OP_GLUE_9862, OP_GLUE_9863,
    OP_GLUE_9860, OP_GLUE_9861, OP_GLUE_9862, OP_GLUE_9863,
    OP_GLUE_9860, OP_GLUE_9861, OP_GLUE_9862, OP_GLUE_9863,

    // 1001 1000 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 1000 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 1000 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 1000 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 1000 1100 0000
    OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0,
    OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0,
    OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0,
    OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0,

    // 1001 1000 1101 0000
    OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0,
    OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0,
    OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0,
    OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0,

    // 1001 1000 1110 0000
    OP_GLUE_98E0, OP_GLUE_98E1, OP_GLUE_98E2, OP_GLUE_98E3,
    OP_GLUE_98E0, OP_GLUE_98E1, OP_GLUE_98E2, OP_GLUE_98E3,
    OP_GLUE_98E0, OP_GLUE_98E1, OP_GLUE_98E2, OP_GLUE_98E3,
    OP_GLUE_98E0, OP_GLUE_98E1, OP_GLUE_98E2, OP_GLUE_98E3,

    // 1001 1000 1111 0000
    OP_GLUE_98E0, OP_GLUE_98E1, OP_GLUE_98E2, OP_GLUE_98E3,
    OP_GLUE_98E0, OP_GLUE_98E1, OP_GLUE_98E2, OP_GLUE_98E3,
    OP_GLUE_98E0, OP_GLUE_98E1, OP_GLUE_98E2, OP_GLUE_98E3,
    OP_GLUE_98E0, OP_GLUE_98E1, OP_GLUE_98E2, OP_GLUE_98E3,

    // 1001 1001 0000 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 1001 0001 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9018, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 1001 0010 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 1001 0011 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 1001 0100 0000
    OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840,
    OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840,
    OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840,
    OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840,

    // 1001 1001 0101 0000
    OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840,
    OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840,
    OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840,
    OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840, OP_GLUE_9840,

    // 1001 1001 0110 0000
    OP_GLUE_9960, OP_GLUE_9861, OP_GLUE_9862, OP_GLUE_9863,
    OP_GLUE_9960, OP_GLUE_9861, OP_GLUE_9862, OP_GLUE_9863,
    OP_GLUE_9960, OP_GLUE_9861, OP_GLUE_9862, OP_GLUE_9863,
    OP_GLUE_9960, OP_GLUE_9861, OP_GLUE_9862, OP_GLUE_9863,

    // 1001 1001 0111 0000
    OP_GLUE_9960, OP_GLUE_9861, OP_GLUE_9862, OP_GLUE_9863,
    OP_GLUE_9960, OP_GLUE_9861, OP_GLUE_9862, OP_GLUE_9863,
    OP_GLUE_9960, OP_GLUE_9861, OP_GLUE_9862, OP_GLUE_9863,
    OP_GLUE_9960, OP_GLUE_9861, OP_GLUE_9862, OP_GLUE_9863,

    // 1001 1001 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 1001 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 1001 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 1001 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 1001 1100 0000
    OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0,
    OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0,
    OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0,
    OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0,

    // 1001 1001 1101 0000
    OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0,
    OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0,
    OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0,
    OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0, OP_GLUE_98C0,

    // 1001 1001 1110 0000
    OP_GLUE_99E0, OP_GLUE_98E1, OP_GLUE_98E2, OP_GLUE_98E3,
    OP_GLUE_99E0, OP_GLUE_98E1, OP_GLUE_98E2, OP_GLUE_98E3,
    OP_GLUE_99E0, OP_GLUE_98E1, OP_GLUE_98E2, OP_GLUE_98E3,
    OP_GLUE_99E0, OP_GLUE_98E1, OP_GLUE_98E2, OP_GLUE_98E3,

    // 1001 1001 1111 0000
    OP_GLUE_99E0, OP_GLUE_98E1, OP_GLUE_98E2, OP_GLUE_98E3,
    OP_GLUE_99E0, OP_GLUE_98E1, OP_GLUE_98E2, OP_GLUE_98E3,
    OP_GLUE_99E0, OP_GLUE_98E1, OP_GLUE_98E2, OP_GLUE_98E3,
    OP_GLUE_99E0, OP_GLUE_98E1, OP_GLUE_98E2, OP_GLUE_98E3,

    // 1001 1010 0000 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 1010 0001 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9018, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 1010 0010 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 1010 0011 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 1010 0100 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1010 0101 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1010 0110 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1010 0111 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1010 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 1010 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 1010 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 1010 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 1010 1100 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1010 1101 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1010 1110 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1010 1111 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1011 0000 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 1011 0001 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9018, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 1011 0010 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 1011 0011 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 1011 0100 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1011 0101 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1011 0110 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1011 0111 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1011 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 1011 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 1011 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 1011 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 1011 1100 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1011 1101 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1011 1110 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1011 1111 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1100 0000 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 1100 0001 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9018, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 1100 0010 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 1100 0011 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 1100 0100 0000
    OP_GLUE_9C40, OP_GLUE_9C40, OP_GLUE_9C40, OP_GLUE_9C40,
    OP_GLUE_9C40, OP_GLUE_9C40, OP_GLUE_9C40, OP_GLUE_9C40,
    OP_GLUE_9C40, OP_GLUE_9C40, OP_GLUE_9C40, OP_GLUE_9C40,
    OP_GLUE_9C40, OP_GLUE_9C40, OP_GLUE_9C40, OP_GLUE_9C40,

    // 1001 1100 0101 0000
    OP_GLUE_9C40, OP_GLUE_9C40, OP_GLUE_9C40, OP_GLUE_9C40,
    OP_GLUE_9C40, OP_GLUE_9C40, OP_GLUE_9C40, OP_GLUE_9C40,
    OP_GLUE_9C40, OP_GLUE_9C40, OP_GLUE_9C40, OP_GLUE_9C40,
    OP_GLUE_9C40, OP_GLUE_9C40, OP_GLUE_9C40, OP_GLUE_9C40,

    // 1001 1100 0110 0000
    OP_GLUE_9C60, OP_GLUE_9C60, OP_GLUE_9C60, OP_GLUE_9C60,
    OP_GLUE_9C60, OP_GLUE_9C60, OP_GLUE_9C60, OP_GLUE_9C60,
    OP_GLUE_9C60, OP_GLUE_9C60, OP_GLUE_9C60, OP_GLUE_9C60,
    OP_GLUE_9C60, OP_GLUE_9C60, OP_GLUE_9C60, OP_GLUE_9C60,

    // 1001 1100 0111 0000
    OP_GLUE_9C60, OP_GLUE_9C60, OP_GLUE_9C60, OP_GLUE_9C60,
    OP_GLUE_9C60, OP_GLUE_9C60, OP_GLUE_9C60, OP_GLUE_9C60,
    OP_GLUE_9C60, OP_GLUE_9C60, OP_GLUE_9C60, OP_GLUE_9C60,
    OP_GLUE_9C60, OP_GLUE_9C60, OP_GLUE_9C60, OP_GLUE_9C60,

    // 1001 1100 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 1100 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 1100 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 1100 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 1100 1100 0000
    OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0,
    OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0,
    OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0,
    OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0,

    // 1001 1100 1101 0000
    OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0,
    OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0,
    OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0,
    OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0,

    // 1001 1100 1110 0000
    OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0,
    OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0,
    OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0,
    OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0,

    // 1001 1100 1111 0000
    OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0,
    OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0,
    OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0,
    OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0,

    // 1001 1101 0000 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 1101 0001 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9018, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 1101 0010 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 1101 0011 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 1101 0100 0000
    OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40,
    OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40,
    OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40,
    OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40,

    // 1001 1101 0101 0000
    OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40,
    OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40,
    OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40,
    OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40,

    // 1001 1101 0110 0000
    OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40,
    OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40,
    OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40,
    OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40,

    // 1001 1101 0111 0000
    OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40,
    OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40,
    OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40,
    OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40, OP_GLUE_9D40,

    // 1001 1101 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 1101 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 1101 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 1101 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 1101 1100 0000
    OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0,
    OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0,
    OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0,
    OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0,

    // 1001 1101 1101 0000
    OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0,
    OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0,
    OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0,
    OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0, OP_GLUE_9CC0,

    // 1001 1101 1110 0000
    OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0,
    OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0,
    OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0,
    OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0,

    // 1001 1101 1111 0000
    OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0,
    OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0,
    OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0,
    OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0, OP_GLUE_9CE0,

    // 1001 1110 0000 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 1110 0001 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9018, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 1110 0010 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 1110 0011 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 1110 0100 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1110 0101 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1110 0110 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1110 0111 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1110 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 1110 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 1110 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 1110 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 1110 1100 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1110 1101 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1110 1110 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1110 1111 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1111 0000 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 1111 0001 0000
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9018, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,
    OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000, OP_GLUE_9000,

    // 1001 1111 0010 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 1111 0011 0000
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,
    OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020, OP_GLUE_9020,

    // 1001 1111 0100 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1111 0101 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1111 0110 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1111 0111 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1111 1000 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 1111 1001 0000
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,
    OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080, OP_GLUE_8080,

    // 1001 1111 1010 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 1111 1011 0000
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,
    OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0, OP_GLUE_80A0,

    // 1001 1111 1100 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1111 1101 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1111 1110 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1001 1111 1111 0000
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,
    OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240, OP_GLUE_9240,

    // 1010 0000 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0000 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0000 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0000 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0000 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0000 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0000 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0000 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0000 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0000 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0000 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0000 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0000 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0000 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0000 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0000 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0001 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0001 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0001 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0001 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0001 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0001 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0001 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0001 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0001 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0001 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0001 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0001 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0001 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0001 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0001 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0001 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0010 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0010 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0010 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0010 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0010 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0010 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0010 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0010 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0010 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0010 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0010 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0010 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0010 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0010 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0010 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0010 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0011 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0011 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0011 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0011 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0011 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0011 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0011 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0011 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0011 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0011 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0011 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0011 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0011 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0011 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0011 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0011 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0100 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0100 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0100 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0100 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0100 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0100 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0100 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0100 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0100 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0100 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0100 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0100 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0100 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0100 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0100 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0100 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0101 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0101 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0101 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0101 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0101 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0101 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0101 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0101 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0101 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0101 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0101 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0101 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0101 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0101 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0101 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0101 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0110 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0110 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0110 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0110 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0110 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0110 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0110 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0110 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0110 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0110 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0110 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0110 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0110 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0110 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0110 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0110 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0111 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0111 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0111 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0111 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0111 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0111 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0111 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0111 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0111 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0111 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0111 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0111 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0111 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0111 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0111 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 0111 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1000 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1000 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1000 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1000 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1000 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1000 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1000 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1000 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1000 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1000 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1000 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1000 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1000 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1000 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1000 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1000 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1001 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1001 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1001 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1001 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1001 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1001 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1001 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1001 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1001 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1001 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1001 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1001 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1001 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1001 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1001 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1001 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1010 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1010 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1010 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1010 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1010 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1010 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1010 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1010 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1010 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1010 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1010 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1010 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1010 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1010 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1010 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1010 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1011 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1011 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1011 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1011 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1011 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1011 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1011 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1011 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1011 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1011 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1011 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1011 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1011 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1011 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1011 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1011 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1100 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1100 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1100 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1100 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1100 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1100 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1100 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1100 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1100 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1100 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1100 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1100 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1100 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1100 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1100 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1100 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1101 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1101 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1101 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1101 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1101 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1101 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1101 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1101 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1101 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1101 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1101 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1101 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1101 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1101 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1101 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1101 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1110 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1110 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1110 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1110 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1110 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1110 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1110 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1110 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1110 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1110 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1110 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1110 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1110 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1110 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1110 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1110 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1111 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1111 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1111 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1111 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1111 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1111 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1111 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1111 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1111 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1111 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1111 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1111 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1111 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1111 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1111 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1010 1111 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0000 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0000 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0000 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0000 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0000 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0000 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0000 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0000 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0000 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0000 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0000 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0000 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0000 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0000 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0000 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0000 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0001 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0001 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0001 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0001 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0001 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0001 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0001 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0001 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0001 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0001 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0001 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0001 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0001 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0001 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0001 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0001 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0010 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0010 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0010 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0010 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0010 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0010 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0010 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0010 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0010 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0010 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0010 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0010 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0010 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0010 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0010 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0010 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0011 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0011 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0011 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0011 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0011 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0011 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0011 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0011 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0011 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0011 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0011 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0011 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0011 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0011 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0011 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0011 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0100 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0100 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0100 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0100 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0100 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0100 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0100 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0100 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0100 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0100 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0100 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0100 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0100 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0100 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0100 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0100 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0101 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0101 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0101 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0101 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0101 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0101 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0101 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0101 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0101 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0101 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0101 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0101 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0101 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0101 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0101 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0101 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0110 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0110 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0110 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0110 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0110 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0110 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0110 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0110 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0110 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0110 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0110 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0110 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0110 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0110 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0110 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0110 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0111 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0111 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0111 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0111 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0111 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0111 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0111 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0111 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0111 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0111 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0111 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0111 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0111 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0111 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0111 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 0111 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1000 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1000 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1000 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1000 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1000 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1000 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1000 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1000 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1000 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1000 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1000 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1000 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1000 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1000 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1000 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1000 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1001 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1001 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1001 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1001 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1001 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1001 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1001 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1001 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1001 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1001 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1001 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1001 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1001 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1001 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1001 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1001 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1010 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1010 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1010 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1010 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1010 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1010 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1010 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1010 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1010 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1010 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1010 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1010 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1010 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1010 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1010 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1010 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1011 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1011 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1011 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1011 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1011 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1011 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1011 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1011 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1011 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1011 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1011 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1011 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1011 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1011 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1011 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1011 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1100 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1100 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1100 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1100 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1100 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1100 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1100 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1100 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1100 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1100 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1100 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1100 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1100 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1100 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1100 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1100 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1101 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1101 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1101 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1101 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1101 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1101 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1101 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1101 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1101 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1101 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1101 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1101 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1101 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1101 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1101 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1101 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1110 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1110 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1110 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1110 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1110 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1110 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1110 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1110 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1110 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1110 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1110 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1110 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1110 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1110 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1110 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1110 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1111 0000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1111 0001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1111 0010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1111 0011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1111 0100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1111 0101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1111 0110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1111 0111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1111 1000 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1111 1001 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1111 1010 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1111 1011 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1111 1100 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1111 1101 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1111 1110 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1011 1111 1111 0000
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,
    OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000, OP_GLUE_A000,

    // 1100 0000 0000 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0000 0001 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0000 0010 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0000 0011 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0000 0100 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0000 0101 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0000 0110 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0000 0111 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0000 1000 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0000 1001 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0000 1010 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0000 1011 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0000 1100 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0000 1101 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0000 1110 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0000 1111 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0001 0000 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0001 0001 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0001 0010 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0001 0011 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0001 0100 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0001 0101 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0001 0110 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0001 0111 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0001 1000 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0001 1001 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0001 1010 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0001 1011 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0001 1100 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0001 1101 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0001 1110 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0001 1111 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0010 0000 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0010 0001 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0010 0010 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0010 0011 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0010 0100 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0010 0101 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0010 0110 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0010 0111 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0010 1000 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0010 1001 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0010 1010 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0010 1011 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0010 1100 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0010 1101 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0010 1110 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0010 1111 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0011 0000 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0011 0001 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0011 0010 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0011 0011 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0011 0100 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0011 0101 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0011 0110 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0011 0111 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0011 1000 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0011 1001 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0011 1010 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0011 1011 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0011 1100 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0011 1101 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0011 1110 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0011 1111 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0100 0000 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0100 0001 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0100 0010 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0100 0011 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0100 0100 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0100 0101 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0100 0110 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0100 0111 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0100 1000 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0100 1001 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0100 1010 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0100 1011 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0100 1100 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0100 1101 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0100 1110 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0100 1111 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0101 0000 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0101 0001 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0101 0010 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0101 0011 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0101 0100 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0101 0101 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0101 0110 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0101 0111 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0101 1000 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0101 1001 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0101 1010 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0101 1011 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0101 1100 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0101 1101 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0101 1110 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0101 1111 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0110 0000 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0110 0001 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0110 0010 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0110 0011 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0110 0100 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0110 0101 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0110 0110 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0110 0111 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0110 1000 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0110 1001 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0110 1010 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0110 1011 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0110 1100 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0110 1101 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0110 1110 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0110 1111 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0111 0000 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0111 0001 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0111 0010 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0111 0011 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0111 0100 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0111 0101 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0111 0110 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0111 0111 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0111 1000 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0111 1001 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0111 1010 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0111 1011 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0111 1100 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0111 1101 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0111 1110 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 0111 1111 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1000 0000 0000
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,

    // 1100 1000 0001 0000
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,

    // 1100 1000 0010 0000
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,

    // 1100 1000 0011 0000
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,

    // 1100 1000 0100 0000
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,

    // 1100 1000 0101 0000
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,

    // 1100 1000 0110 0000
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,

    // 1100 1000 0111 0000
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,

    // 1100 1000 1000 0000
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,

    // 1100 1000 1001 0000
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,

    // 1100 1000 1010 0000
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,

    // 1100 1000 1011 0000
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,

    // 1100 1000 1100 0000
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,

    // 1100 1000 1101 0000
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,

    // 1100 1000 1110 0000
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,

    // 1100 1000 1111 0000
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,
    OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800, OP_GLUE_C800,

    // 1100 1001 0000 0000
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,

    // 1100 1001 0001 0000
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,

    // 1100 1001 0010 0000
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,

    // 1100 1001 0011 0000
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,

    // 1100 1001 0100 0000
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,

    // 1100 1001 0101 0000
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,

    // 1100 1001 0110 0000
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,

    // 1100 1001 0111 0000
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,

    // 1100 1001 1000 0000
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,

    // 1100 1001 1001 0000
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,

    // 1100 1001 1010 0000
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,

    // 1100 1001 1011 0000
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,

    // 1100 1001 1100 0000
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,

    // 1100 1001 1101 0000
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,

    // 1100 1001 1110 0000
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,

    // 1100 1001 1111 0000
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,
    OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900, OP_GLUE_C900,

    // 1100 1010 0000 0000
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,

    // 1100 1010 0001 0000
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,

    // 1100 1010 0010 0000
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,

    // 1100 1010 0011 0000
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,

    // 1100 1010 0100 0000
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,

    // 1100 1010 0101 0000
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,

    // 1100 1010 0110 0000
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,

    // 1100 1010 0111 0000
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,

    // 1100 1010 1000 0000
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,

    // 1100 1010 1001 0000
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,

    // 1100 1010 1010 0000
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,

    // 1100 1010 1011 0000
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,

    // 1100 1010 1100 0000
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,

    // 1100 1010 1101 0000
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,

    // 1100 1010 1110 0000
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,

    // 1100 1010 1111 0000
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,
    OP_GLUE_CA00, OP_GLUE_CA01, OP_GLUE_CA02, OP_GLUE_CA03,
    OP_GLUE_CA04, OP_GLUE_CA05, OP_GLUE_CA06, OP_GLUE_CA07,

    // 1100 1011 0000 0000
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,

    // 1100 1011 0001 0000
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,

    // 1100 1011 0010 0000
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,

    // 1100 1011 0011 0000
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,

    // 1100 1011 0100 0000
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,

    // 1100 1011 0101 0000
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,

    // 1100 1011 0110 0000
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,

    // 1100 1011 0111 0000
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,

    // 1100 1011 1000 0000
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,

    // 1100 1011 1001 0000
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,

    // 1100 1011 1010 0000
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,

    // 1100 1011 1011 0000
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,

    // 1100 1011 1100 0000
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,

    // 1100 1011 1101 0000
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,

    // 1100 1011 1110 0000
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,

    // 1100 1011 1111 0000
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,
    OP_GLUE_CB00, OP_GLUE_CB01, OP_GLUE_CB02, OP_GLUE_CB03,
    OP_GLUE_CB04, OP_GLUE_CB05, OP_GLUE_CB06, OP_GLUE_CB07,

    // 1100 1100 0000 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1100 0001 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1100 0010 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1100 0011 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1100 0100 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1100 0101 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1100 0110 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1100 0111 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1100 1000 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1100 1001 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1100 1010 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1100 1011 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1100 1100 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1100 1101 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1100 1110 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1100 1111 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1101 0000 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1101 0001 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1101 0010 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1101 0011 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1101 0100 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1101 0101 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1101 0110 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1101 0111 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1101 1000 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1101 1001 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1101 1010 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1101 1011 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1101 1100 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1101 1101 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1101 1110 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1101 1111 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1110 0000 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1110 0001 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1110 0010 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1110 0011 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1110 0100 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1110 0101 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1110 0110 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1110 0111 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1110 1000 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1110 1001 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1110 1010 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1110 1011 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1110 1100 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1110 1101 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1110 1110 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1110 1111 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1111 0000 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1111 0001 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1111 0010 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1111 0011 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1111 0100 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1111 0101 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1111 0110 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1111 0111 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1111 1000 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1111 1001 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1111 1010 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1111 1011 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1111 1100 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1111 1101 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1111 1110 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1100 1111 1111 0000
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,
    OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000, OP_GLUE_C000,

    // 1101 0000 0000 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0000 0001 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0000 0010 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0000 0011 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0000 0100 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0000 0101 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0000 0110 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0000 0111 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0000 1000 0000
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,

    // 1101 0000 1001 0000
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,

    // 1101 0000 1010 0000
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,

    // 1101 0000 1011 0000
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,

    // 1101 0000 1100 0000
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,

    // 1101 0000 1101 0000
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,

    // 1101 0000 1110 0000
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,

    // 1101 0000 1111 0000
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,

    // 1101 0001 0000 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0001 0001 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0001 0010 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0001 0011 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0001 0100 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0001 0101 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0001 0110 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0001 0111 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0001 1000 0000
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,

    // 1101 0001 1001 0000
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,

    // 1101 0001 1010 0000
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,

    // 1101 0001 1011 0000
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,

    // 1101 0001 1100 0000
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,

    // 1101 0001 1101 0000
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,

    // 1101 0001 1110 0000
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,

    // 1101 0001 1111 0000
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,
    OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080, OP_GLUE_D080,

    // 1101 0010 0000 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0010 0001 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0010 0010 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0010 0011 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0010 0100 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0010 0101 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0010 0110 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0010 0111 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0010 1000 0000
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,

    // 1101 0010 1001 0000
    OP_GLUE_D290, OP_GLUE_D291, OP_GLUE_D292, OP_GLUE_D292,
    OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294,
    OP_GLUE_D298, OP_GLUE_D299, OP_GLUE_D29A, OP_GLUE_D29A,
    OP_GLUE_D29C, OP_GLUE_D29C, OP_GLUE_D29C, OP_GLUE_D29C,

    // 1101 0010 1010 0000
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,

    // 1101 0010 1011 0000
    OP_GLUE_D290, OP_GLUE_D291, OP_GLUE_D292, OP_GLUE_D292,
    OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294,
    OP_GLUE_D2B8, OP_GLUE_D2B8, OP_GLUE_D2B8, OP_GLUE_D2B8,
    OP_GLUE_D2B8, OP_GLUE_D2B8, OP_GLUE_D2B8, OP_GLUE_D2B8,

    // 1101 0010 1100 0000
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,

    // 1101 0010 1101 0000
    OP_GLUE_D290, OP_GLUE_D291, OP_GLUE_D292, OP_GLUE_D292,
    OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294,
    OP_GLUE_D2D8, OP_GLUE_D2D9, OP_GLUE_D2DA, OP_GLUE_D2DA,
    OP_GLUE_D2DC, OP_GLUE_D2DC, OP_GLUE_D2DC, OP_GLUE_D2DC,

    // 1101 0010 1110 0000
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,

    // 1101 0010 1111 0000
    OP_GLUE_D290, OP_GLUE_D291, OP_GLUE_D292, OP_GLUE_D292,
    OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294,
    OP_GLUE_D2F8, OP_GLUE_D2F8, OP_GLUE_D2F8, OP_GLUE_D2F8,
    OP_GLUE_D2F8, OP_GLUE_D2F8, OP_GLUE_D2F8, OP_GLUE_D2F8,

    // 1101 0011 0000 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0011 0001 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0011 0010 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0011 0011 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0011 0100 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0011 0101 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0011 0110 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0011 0111 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0011 1000 0000
    OP_GLUE_D380, OP_GLUE_D381, OP_GLUE_D382, OP_GLUE_D383,
    OP_GLUE_D384, OP_GLUE_D384, OP_GLUE_D384, OP_GLUE_D384,
    OP_GLUE_D388, OP_GLUE_D389, OP_GLUE_D38A, OP_GLUE_D38B,
    OP_GLUE_D38C, OP_GLUE_D38D, OP_GLUE_D38E, OP_GLUE_D38F,

    // 1101 0011 1001 0000
    OP_GLUE_D390, OP_GLUE_D381, OP_GLUE_D382, OP_GLUE_D383,
    OP_GLUE_D394, OP_GLUE_D394, OP_GLUE_D394, OP_GLUE_D394,
    OP_GLUE_D388, OP_GLUE_D389, OP_GLUE_D38A, OP_GLUE_D38B,
    OP_GLUE_D38C, OP_GLUE_D38D, OP_GLUE_D38E, OP_GLUE_D38F,

    // 1101 0011 1010 0000
    OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0,
    OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0,
    OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0,
    OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0,

    // 1101 0011 1011 0000
    OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0,
    OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0,
    OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0,
    OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0,

    // 1101 0011 1100 0000
    OP_GLUE_D3C0, OP_UNDEFINED, OP_GLUE_D3C2, OP_GLUE_D3C3,
    OP_GLUE_D3C4, OP_GLUE_D3C4, OP_GLUE_D3C4, OP_GLUE_D3C4,
    OP_GLUE_D3C8, OP_GLUE_D3C8, OP_GLUE_D3C8, OP_GLUE_D3C8,
    OP_GLUE_D3C8, OP_GLUE_D3C8, OP_GLUE_D3C8, OP_GLUE_D3C8,

    // 1101 0011 1101 0000
    OP_GLUE_D3D0, OP_GLUE_D3D0, OP_GLUE_D3D0, OP_GLUE_D3D0,
    OP_GLUE_D3D0, OP_GLUE_D3D0, OP_GLUE_D3D0, OP_GLUE_D3D0,
    OP_GLUE_D3D0, OP_GLUE_D3D0, OP_GLUE_D3D0, OP_GLUE_D3D0,
    OP_GLUE_D3D0, OP_GLUE_D3D0, OP_GLUE_D3D0, OP_GLUE_D3D0,

    // 1101 0011 1110 0000
    OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0,
    OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0,
    OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0,
    OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0,

    // 1101 0011 1111 0000
    OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0,
    OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0,
    OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0,
    OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0, OP_GLUE_D3A0,

    // 1101 0100 0000 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0100 0001 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0100 0010 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0100 0011 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0100 0100 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0100 0101 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0100 0110 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0100 0111 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0100 1000 0000
    OP_GLUE_D480, OP_GLUE_D481, OP_GLUE_D482, OP_GLUE_D483,
    OP_GLUE_D484, OP_GLUE_D484, OP_GLUE_D484, OP_GLUE_D484,
    OP_GLUE_D488, OP_GLUE_D488, OP_GLUE_D488, OP_GLUE_D488,
    OP_GLUE_D488, OP_GLUE_D488, OP_GLUE_D488, OP_GLUE_D488,

    // 1101 0100 1001 0000
    OP_GLUE_D490, OP_GLUE_D491, OP_GLUE_D492, OP_GLUE_D493,
    OP_GLUE_D494, OP_GLUE_D495, OP_GLUE_D496, OP_GLUE_D496,
    OP_GLUE_D498, OP_GLUE_D499, OP_UNDEFINED, OP_GLUE_D49B,
    OP_GLUE_D49C, OP_GLUE_D49D, OP_GLUE_D49E, OP_GLUE_D49E,

    // 1101 0100 1010 0000
    OP_GLUE_D4A0, OP_GLUE_D4A0, OP_GLUE_D4A0, OP_GLUE_D4A0,
    OP_GLUE_D4A4, OP_GLUE_D4A4, OP_GLUE_D4A4, OP_GLUE_D4A4,
    OP_GLUE_D488, OP_GLUE_D488, OP_GLUE_D488, OP_GLUE_D488,
    OP_GLUE_D488, OP_GLUE_D488, OP_GLUE_D488, OP_GLUE_D488,

    // 1101 0100 1011 0000
    OP_GLUE_D490, OP_GLUE_D491, OP_GLUE_D492, OP_GLUE_D493,
    OP_GLUE_D4B4, OP_GLUE_D4B4, OP_GLUE_D4B4, OP_GLUE_D4B4,
    OP_GLUE_D4B8, OP_GLUE_D4B9, OP_GLUE_D4BA, OP_GLUE_D4BA,
    OP_GLUE_D4BC, OP_GLUE_D49D, OP_GLUE_D49E, OP_GLUE_D49E,

    // 1101 0100 1100 0000
    OP_GLUE_D4C0, OP_GLUE_D4C0, OP_GLUE_D4C0, OP_GLUE_D4C0,
    OP_GLUE_D4C0, OP_GLUE_D4C0, OP_GLUE_D4C0, OP_GLUE_D4C0,
    OP_GLUE_D4C0, OP_GLUE_D4C0, OP_GLUE_D4C0, OP_GLUE_D4C0,
    OP_GLUE_D4C0, OP_GLUE_D4C0, OP_GLUE_D4C0, OP_GLUE_D4C0,

    // 1101 0100 1101 0000
    OP_GLUE_D490, OP_GLUE_D491, OP_GLUE_D492, OP_GLUE_D493,
    OP_GLUE_D4D4, OP_GLUE_D4D5, OP_GLUE_D4D6, OP_GLUE_D4D7,
    OP_GLUE_D4D8, OP_GLUE_D4D8, OP_GLUE_D4D8, OP_GLUE_D4D8,
    OP_UNDEFINED, OP_UNDEFINED, OP_GLUE_D4D8, OP_GLUE_D4D8,

    // 1101 0100 1110 0000
    OP_GLUE_D4C0, OP_GLUE_D4C0, OP_GLUE_D4C0, OP_GLUE_D4C0,
    OP_GLUE_D4C0, OP_GLUE_D4C0, OP_GLUE_D4C0, OP_GLUE_D4C0,
    OP_GLUE_D4C0, OP_GLUE_D4C0, OP_GLUE_D4C0, OP_GLUE_D4C0,
    OP_GLUE_D4C0, OP_GLUE_D4C0, OP_GLUE_D4C0, OP_GLUE_D4C0,

    // 1101 0100 1111 0000
    OP_GLUE_D490, OP_GLUE_D491, OP_GLUE_D492, OP_GLUE_D493,
    OP_GLUE_D4D4, OP_GLUE_D4D5, OP_GLUE_D4D6, OP_GLUE_D4D7,
    OP_GLUE_D4F8, OP_GLUE_D4F8, OP_GLUE_D4F8, OP_GLUE_D4F8,
    OP_UNDEFINED, OP_UNDEFINED, OP_GLUE_D4F8, OP_GLUE_D4F8,

    // 1101 0101 0000 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0101 0001 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0101 0010 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0101 0011 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0101 0100 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0101 0101 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0101 0110 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0101 0111 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0101 1000 0000
    OP_GLUE_D480, OP_GLUE_D481, OP_GLUE_D582, OP_GLUE_D583,
    OP_GLUE_D584, OP_GLUE_D584, OP_GLUE_D584, OP_GLUE_D584,
    OP_GLUE_D488, OP_GLUE_D488, OP_GLUE_D488, OP_GLUE_D488,
    OP_GLUE_D488, OP_GLUE_D488, OP_GLUE_D488, OP_GLUE_D488,

    // 1101 0101 1001 0000
    OP_GLUE_D590, OP_GLUE_D590, OP_GLUE_D590, OP_GLUE_D590,
    OP_GLUE_D590, OP_GLUE_D590, OP_GLUE_D590, OP_GLUE_D590,
    OP_GLUE_D498, OP_GLUE_D499, OP_UNDEFINED, OP_GLUE_D59B,
    OP_GLUE_D49C, OP_GLUE_D59D, OP_GLUE_D49E, OP_GLUE_D49E,

    // 1101 0101 1010 0000
    OP_GLUE_D5A0, OP_GLUE_D5A0, OP_GLUE_D5A0, OP_GLUE_D5A0,
    OP_GLUE_D4A4, OP_GLUE_D4A4, OP_GLUE_D4A4, OP_GLUE_D4A4,
    OP_GLUE_D488, OP_GLUE_D488, OP_GLUE_D488, OP_GLUE_D488,
    OP_GLUE_D488, OP_GLUE_D488, OP_GLUE_D488, OP_GLUE_D488,

    // 1101 0101 1011 0000
    OP_GLUE_D590, OP_GLUE_D590, OP_GLUE_D590, OP_GLUE_D590,
    OP_GLUE_D590, OP_GLUE_D590, OP_GLUE_D590, OP_GLUE_D590,
    OP_GLUE_D4B8, OP_GLUE_D4B9, OP_GLUE_D4BA, OP_GLUE_D4BA,
    OP_GLUE_D4BC, OP_GLUE_D59D, OP_GLUE_D49E, OP_GLUE_D49E,

    // 1101 0101 1100 0000
    OP_GLUE_D5C0, OP_GLUE_D5C0, OP_GLUE_D5C0, OP_GLUE_D5C0,
    OP_GLUE_D5C0, OP_GLUE_D5C0, OP_GLUE_D5C0, OP_GLUE_D5C0,
    OP_GLUE_D5C0, OP_GLUE_D5C0, OP_GLUE_D5C0, OP_GLUE_D5C0,
    OP_GLUE_D5C0, OP_GLUE_D5C0, OP_GLUE_D5C0, OP_GLUE_D5C0,

    // 1101 0101 1101 0000
    OP_GLUE_D590, OP_GLUE_D590, OP_GLUE_D590, OP_GLUE_D590,
    OP_GLUE_D590, OP_GLUE_D590, OP_GLUE_D590, OP_GLUE_D590,
    OP_GLUE_D4D8, OP_GLUE_D4D8, OP_GLUE_D4D8, OP_GLUE_D4D8,
    OP_UNDEFINED, OP_UNDEFINED, OP_GLUE_D4D8, OP_GLUE_D4D8,

    // 1101 0101 1110 0000
    OP_GLUE_D5E0, OP_GLUE_D5E0, OP_GLUE_D5E0, OP_GLUE_D5E0,
    OP_GLUE_D5E4, OP_GLUE_D5E4, OP_GLUE_D5E4, OP_GLUE_D5E4,
    OP_GLUE_D5E0, OP_GLUE_D5E0, OP_GLUE_D5E0, OP_GLUE_D5E0,
    OP_GLUE_D5E4, OP_GLUE_D5E4, OP_GLUE_D5E4, OP_GLUE_D5E4,

    // 1101 0101 1111 0000
    OP_GLUE_D590, OP_GLUE_D590, OP_GLUE_D590, OP_GLUE_D590,
    OP_GLUE_D590, OP_GLUE_D590, OP_GLUE_D590, OP_GLUE_D590,
    OP_GLUE_D4F8, OP_GLUE_D4F8, OP_GLUE_D4F8, OP_GLUE_D4F8,
    OP_UNDEFINED, OP_UNDEFINED, OP_GLUE_D4F8, OP_GLUE_D4F8,

    // 1101 0110 0000 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0110 0001 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0110 0010 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0110 0011 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0110 0100 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0110 0101 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0110 0110 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0110 0111 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0110 1000 0000
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,

    // 1101 0110 1001 0000
    OP_GLUE_D290, OP_GLUE_D291, OP_GLUE_D292, OP_GLUE_D292,
    OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294,
    OP_GLUE_D298, OP_GLUE_D299, OP_GLUE_D69A, OP_GLUE_D69A,
    OP_GLUE_D29C, OP_GLUE_D29C, OP_GLUE_D29C, OP_GLUE_D29C,

    // 1101 0110 1010 0000
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,

    // 1101 0110 1011 0000
    OP_GLUE_D290, OP_GLUE_D291, OP_GLUE_D292, OP_GLUE_D292,
    OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294,
    OP_GLUE_D2B8, OP_GLUE_D2B8, OP_GLUE_D2B8, OP_GLUE_D2B8,
    OP_GLUE_D2B8, OP_GLUE_D2B8, OP_GLUE_D2B8, OP_GLUE_D2B8,

    // 1101 0110 1100 0000
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,

    // 1101 0110 1101 0000
    OP_GLUE_D290, OP_GLUE_D291, OP_GLUE_D292, OP_GLUE_D292,
    OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294,
    OP_GLUE_D2D8, OP_GLUE_D2D9, OP_GLUE_D2DA, OP_GLUE_D2DA,
    OP_GLUE_D2DC, OP_GLUE_D2DC, OP_GLUE_D2DC, OP_GLUE_D2DC,

    // 1101 0110 1110 0000
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,

    // 1101 0110 1111 0000
    OP_GLUE_D290, OP_GLUE_D291, OP_GLUE_D292, OP_GLUE_D292,
    OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294,
    OP_GLUE_D2F8, OP_GLUE_D2F8, OP_GLUE_D2F8, OP_GLUE_D2F8,
    OP_GLUE_D2F8, OP_GLUE_D2F8, OP_GLUE_D2F8, OP_GLUE_D2F8,

    // 1101 0111 0000 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0111 0001 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0111 0010 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0111 0011 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0111 0100 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0111 0101 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0111 0110 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0111 0111 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 0111 1000 0000
    OP_GLUE_D780, OP_GLUE_D781, OP_GLUE_D782, OP_GLUE_D782,
    OP_GLUE_D784, OP_GLUE_D784, OP_GLUE_D784, OP_GLUE_D784,
    OP_GLUE_D788, OP_GLUE_D788, OP_GLUE_D788, OP_GLUE_D788,
    OP_GLUE_D78C, OP_GLUE_D78C, OP_GLUE_D78C, OP_GLUE_D78C,

    // 1101 0111 1001 0000
    OP_GLUE_D790, OP_GLUE_D790, OP_GLUE_D790, OP_GLUE_D790,
    OP_GLUE_D790, OP_GLUE_D790, OP_GLUE_D790, OP_GLUE_D790,
    OP_GLUE_D790, OP_GLUE_D790, OP_GLUE_D790, OP_GLUE_D790,
    OP_GLUE_D790, OP_GLUE_D790, OP_GLUE_D790, OP_GLUE_D790,

    // 1101 0111 1010 0000
    OP_GLUE_D7A0, OP_GLUE_D7A1, OP_GLUE_D7A0, OP_GLUE_D7A1,
    OP_GLUE_D7A0, OP_GLUE_D7A1, OP_GLUE_D7A0, OP_GLUE_D7A1,
    OP_GLUE_D7A0, OP_GLUE_D7A1, OP_GLUE_D7A0, OP_GLUE_D7A1,
    OP_GLUE_D7A0, OP_GLUE_D7A1, OP_GLUE_D7A0, OP_GLUE_D7A1,

    // 1101 0111 1011 0000
    OP_GLUE_D7A0, OP_GLUE_D7A1, OP_GLUE_D7A0, OP_GLUE_D7A1,
    OP_GLUE_D7A0, OP_GLUE_D7A1, OP_GLUE_D7A0, OP_GLUE_D7A1,
    OP_GLUE_D7A0, OP_GLUE_D7A1, OP_GLUE_D7A0, OP_GLUE_D7A1,
    OP_GLUE_D7A0, OP_GLUE_D7A1, OP_GLUE_D7A0, OP_GLUE_D7A1,

    // 1101 0111 1100 0000
    OP_GLUE_D7C0, OP_GLUE_D7C1, OP_GLUE_D7C2, OP_GLUE_D7C2,
    OP_GLUE_D3C4, OP_GLUE_D3C4, OP_GLUE_D3C4, OP_GLUE_D3C4,
    OP_GLUE_D7C8, OP_GLUE_D7C8, OP_GLUE_D7C8, OP_GLUE_D7C8,
    OP_GLUE_D7C8, OP_GLUE_D7C8, OP_GLUE_D7C8, OP_GLUE_D7C8,

    // 1101 0111 1101 0000
    OP_GLUE_D7D0, OP_GLUE_D7D0, OP_GLUE_D7D0, OP_GLUE_D7D0,
    OP_GLUE_D7D4, OP_GLUE_D7D4, OP_GLUE_D7D4, OP_GLUE_D7D4,
    OP_GLUE_D7D8, OP_GLUE_D7D8, OP_GLUE_D7D8, OP_GLUE_D7D8,
    OP_GLUE_D7D8, OP_GLUE_D7D8, OP_GLUE_D7D8, OP_GLUE_D7D8,

    // 1101 0111 1110 0000
    OP_GLUE_D7E0, OP_GLUE_D7E0, OP_GLUE_D7E0, OP_GLUE_D7E0,
    OP_GLUE_D7E0, OP_GLUE_D7E0, OP_GLUE_D7E0, OP_GLUE_D7E0,
    OP_GLUE_D7E8, OP_GLUE_D7E8, OP_GLUE_D7E8, OP_GLUE_D7E8,
    OP_GLUE_D7E8, OP_GLUE_D7E8, OP_GLUE_D7E8, OP_GLUE_D7E8,

    // 1101 0111 1111 0000
    OP_GLUE_D7F0, OP_GLUE_D7F0, OP_GLUE_D7F0, OP_GLUE_D7F0,
    OP_GLUE_D7F4, OP_GLUE_D7F4, OP_GLUE_D7F4, OP_GLUE_D7F4,
    OP_GLUE_D7F8, OP_GLUE_D7F8, OP_GLUE_D7F8, OP_GLUE_D7F8,
    OP_GLUE_D7FC, OP_GLUE_D7FC, OP_GLUE_D7FC, OP_GLUE_D7FC,

    // 1101 1000 0000 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1000 0001 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1000 0010 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1000 0011 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1000 0100 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1000 0101 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1000 0110 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1000 0111 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1000 1000 0000
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,

    // 1101 1000 1001 0000
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,

    // 1101 1000 1010 0000
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,

    // 1101 1000 1011 0000
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,

    // 1101 1000 1100 0000
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,

    // 1101 1000 1101 0000
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,

    // 1101 1000 1110 0000
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,

    // 1101 1000 1111 0000
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,

    // 1101 1001 0000 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1001 0001 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1001 0010 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1001 0011 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1001 0100 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1001 0101 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1001 0110 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1001 0111 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1001 1000 0000
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,

    // 1101 1001 1001 0000
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,

    // 1101 1001 1010 0000
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,

    // 1101 1001 1011 0000
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,

    // 1101 1001 1100 0000
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,

    // 1101 1001 1101 0000
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,

    // 1101 1001 1110 0000
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,

    // 1101 1001 1111 0000
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,
    OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880, OP_GLUE_D880,

    // 1101 1010 0000 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1010 0001 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1010 0010 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1010 0011 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1010 0100 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1010 0101 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1010 0110 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1010 0111 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1010 1000 0000
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,

    // 1101 1010 1001 0000
    OP_GLUE_D290, OP_GLUE_D291, OP_GLUE_D292, OP_GLUE_D292,
    OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294,
    OP_GLUE_D298, OP_GLUE_D299, OP_GLUE_DA9A, OP_GLUE_DA9A,
    OP_GLUE_DA9C, OP_GLUE_DA9C, OP_GLUE_DA9C, OP_GLUE_DA9C,

    // 1101 1010 1010 0000
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,

    // 1101 1010 1011 0000
    OP_GLUE_D290, OP_GLUE_D291, OP_GLUE_D292, OP_GLUE_D292,
    OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294,
    OP_GLUE_D2B8, OP_GLUE_D2B8, OP_GLUE_D2B8, OP_GLUE_D2B8,
    OP_GLUE_D2B8, OP_GLUE_D2B8, OP_GLUE_D2B8, OP_GLUE_D2B8,

    // 1101 1010 1100 0000
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,

    // 1101 1010 1101 0000
    OP_GLUE_D290, OP_GLUE_D291, OP_GLUE_D292, OP_GLUE_D292,
    OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294,
    OP_GLUE_D2D8, OP_GLUE_D2D9, OP_GLUE_D2DA, OP_GLUE_D2DA,
    OP_GLUE_DADC, OP_GLUE_DADC, OP_GLUE_DADC, OP_GLUE_DADC,

    // 1101 1010 1110 0000
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,

    // 1101 1010 1111 0000
    OP_GLUE_D290, OP_GLUE_D291, OP_GLUE_D292, OP_GLUE_D292,
    OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294,
    OP_GLUE_D2F8, OP_GLUE_D2F8, OP_GLUE_D2F8, OP_GLUE_D2F8,
    OP_GLUE_D2F8, OP_GLUE_D2F8, OP_GLUE_D2F8, OP_GLUE_D2F8,

    // 1101 1011 0000 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1011 0001 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1011 0010 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1011 0011 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1011 0100 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1011 0101 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1011 0110 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1011 0111 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1011 1000 0000
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,

    // 1101 1011 1001 0000
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,

    // 1101 1011 1010 0000
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,

    // 1101 1011 1011 0000
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,

    // 1101 1011 1100 0000
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,

    // 1101 1011 1101 0000
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,

    // 1101 1011 1110 0000
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,

    // 1101 1011 1111 0000
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,
    OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80, OP_GLUE_DB80,

    // 1101 1100 0000 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1100 0001 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1100 0010 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1100 0011 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1100 0100 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1100 0101 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1100 0110 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1100 0111 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1100 1000 0000
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,

    // 1101 1100 1001 0000
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,

    // 1101 1100 1010 0000
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,

    // 1101 1100 1011 0000
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,

    // 1101 1100 1100 0000
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,

    // 1101 1100 1101 0000
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,

    // 1101 1100 1110 0000
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,

    // 1101 1100 1111 0000
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,

    // 1101 1101 0000 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1101 0001 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1101 0010 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1101 0011 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1101 0100 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1101 0101 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1101 0110 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1101 0111 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1101 1000 0000
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,

    // 1101 1101 1001 0000
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,

    // 1101 1101 1010 0000
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,

    // 1101 1101 1011 0000
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,

    // 1101 1101 1100 0000
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,

    // 1101 1101 1101 0000
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,

    // 1101 1101 1110 0000
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,

    // 1101 1101 1111 0000
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,
    OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80, OP_GLUE_DC80,

    // 1101 1110 0000 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1110 0001 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1110 0010 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1110 0011 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1110 0100 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1110 0101 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1110 0110 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1110 0111 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1110 1000 0000
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,

    // 1101 1110 1001 0000
    OP_GLUE_D290, OP_GLUE_D291, OP_GLUE_D292, OP_GLUE_D292,
    OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294,
    OP_GLUE_D298, OP_GLUE_D299, OP_GLUE_DA9A, OP_GLUE_DA9A,
    OP_GLUE_DE9C, OP_GLUE_DE9C, OP_GLUE_DE9C, OP_GLUE_DE9C,

    // 1101 1110 1010 0000
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,

    // 1101 1110 1011 0000
    OP_GLUE_D290, OP_GLUE_D291, OP_GLUE_D292, OP_GLUE_D292,
    OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294,
    OP_GLUE_D2B8, OP_GLUE_D2B8, OP_GLUE_D2B8, OP_GLUE_D2B8,
    OP_GLUE_D2B8, OP_GLUE_D2B8, OP_GLUE_D2B8, OP_GLUE_D2B8,

    // 1101 1110 1100 0000
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,

    // 1101 1110 1101 0000
    OP_GLUE_D290, OP_GLUE_D291, OP_GLUE_D292, OP_GLUE_D292,
    OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294,
    OP_GLUE_D2D8, OP_GLUE_D2D9, OP_GLUE_D2DA, OP_GLUE_D2DA,
    OP_GLUE_DADC, OP_GLUE_DADC, OP_GLUE_DADC, OP_GLUE_DADC,

    // 1101 1110 1110 0000
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,
    OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280, OP_GLUE_D280,

    // 1101 1110 1111 0000
    OP_GLUE_D290, OP_GLUE_D291, OP_GLUE_D292, OP_GLUE_D292,
    OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294, OP_GLUE_D294,
    OP_GLUE_D2F8, OP_GLUE_D2F8, OP_GLUE_D2F8, OP_GLUE_D2F8,
    OP_GLUE_D2F8, OP_GLUE_D2F8, OP_GLUE_D2F8, OP_GLUE_D2F8,

    // 1101 1111 0000 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1111 0001 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1111 0010 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1111 0011 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1111 0100 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1111 0101 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1111 0110 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1111 0111 0000
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,
    OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000, OP_GLUE_D000,

    // 1101 1111 1000 0000
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,

    // 1101 1111 1001 0000
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,

    // 1101 1111 1010 0000
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,

    // 1101 1111 1011 0000
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,

    // 1101 1111 1100 0000
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,

    // 1101 1111 1101 0000
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,

    // 1101 1111 1110 0000
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,

    // 1101 1111 1111 0000
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,
    OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80, OP_GLUE_DF80,

    // 1110 0000 0000 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0000 0001 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0000 0010 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0000 0011 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0000 0100 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0000 0101 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0000 0110 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0000 0111 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0000 1000 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0000 1001 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0000 1010 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0000 1011 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0000 1100 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0000 1101 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0000 1110 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0000 1111 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0001 0000 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0001 0001 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0001 0010 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0001 0011 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0001 0100 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0001 0101 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0001 0110 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0001 0111 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0001 1000 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0001 1001 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0001 1010 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0001 1011 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0001 1100 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0001 1101 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0001 1110 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0001 1111 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0010 0000 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0010 0001 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0010 0010 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0010 0011 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0010 0100 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0010 0101 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0010 0110 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0010 0111 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0010 1000 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0010 1001 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0010 1010 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0010 1011 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0010 1100 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0010 1101 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0010 1110 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0010 1111 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0011 0000 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0011 0001 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0011 0010 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0011 0011 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0011 0100 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0011 0101 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0011 0110 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0011 0111 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0011 1000 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0011 1001 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0011 1010 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0011 1011 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0011 1100 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0011 1101 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0011 1110 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0011 1111 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0100 0000 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0100 0001 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0100 0010 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0100 0011 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0100 0100 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0100 0101 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0100 0110 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0100 0111 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0100 1000 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0100 1001 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0100 1010 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0100 1011 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0100 1100 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0100 1101 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0100 1110 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0100 1111 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0101 0000 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0101 0001 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0101 0010 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0101 0011 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0101 0100 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0101 0101 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0101 0110 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0101 0111 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0101 1000 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0101 1001 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0101 1010 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0101 1011 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0101 1100 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0101 1101 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0101 1110 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0101 1111 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0110 0000 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0110 0001 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0110 0010 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0110 0011 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0110 0100 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0110 0101 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0110 0110 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0110 0111 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0110 1000 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0110 1001 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0110 1010 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0110 1011 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0110 1100 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0110 1101 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0110 1110 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0110 1111 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 0111 0000 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0111 0001 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0111 0010 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0111 0011 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0111 0100 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0111 0101 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0111 0110 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0111 0111 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0111 1000 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0111 1001 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0111 1010 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0111 1011 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0111 1100 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0111 1101 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0111 1110 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 0111 1111 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1000 0000 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1000 0001 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1000 0010 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1000 0011 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1000 0100 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1000 0101 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1000 0110 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1000 0111 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1000 1000 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1000 1001 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1000 1010 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1000 1011 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1000 1100 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1000 1101 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1000 1110 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1000 1111 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1001 0000 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1001 0001 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1001 0010 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1001 0011 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1001 0100 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1001 0101 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1001 0110 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1001 0111 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1001 1000 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1001 1001 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1001 1010 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1001 1011 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1001 1100 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1001 1101 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1001 1110 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1001 1111 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1010 0000 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1010 0001 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1010 0010 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1010 0011 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1010 0100 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1010 0101 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1010 0110 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1010 0111 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1010 1000 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1010 1001 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1010 1010 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1010 1011 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1010 1100 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1010 1101 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1010 1110 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1010 1111 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1011 0000 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1011 0001 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1011 0010 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1011 0011 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1011 0100 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1011 0101 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1011 0110 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1011 0111 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1011 1000 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1011 1001 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1011 1010 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1011 1011 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1011 1100 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1011 1101 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1011 1110 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1011 1111 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1100 0000 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1100 0001 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1100 0010 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1100 0011 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1100 0100 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1100 0101 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1100 0110 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1100 0111 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1100 1000 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1100 1001 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1100 1010 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1100 1011 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1100 1100 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1100 1101 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1100 1110 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1100 1111 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1101 0000 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1101 0001 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1101 0010 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1101 0011 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1101 0100 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1101 0101 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1101 0110 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1101 0111 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1101 1000 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1101 1001 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1101 1010 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1101 1011 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1101 1100 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1101 1101 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1101 1110 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1101 1111 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1110 0000 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1110 0001 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1110 0010 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1110 0011 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1110 0100 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1110 0101 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1110 0110 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1110 0111 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1110 1000 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1110 1001 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1110 1010 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1110 1011 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1110 1100 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1110 1101 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1110 1110 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1110 1111 0000
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,
    OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000, OP_GLUE_E000,

    // 1110 1111 0000 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1111 0001 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1111 0010 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1111 0011 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1111 0100 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1111 0101 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1111 0110 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1111 0111 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1111 1000 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1111 1001 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1111 1010 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1111 1011 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1111 1100 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1111 1101 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1111 1110 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1110 1111 1111 0000
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,
    OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100, OP_GLUE_E100,

    // 1111 0000 0000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0000 0001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0000 0010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0000 0011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0000 0100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0000 0101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0000 0110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0000 0111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0000 1000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0000 1001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0000 1010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0000 1011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0000 1100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0000 1101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0000 1110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0000 1111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0001 0000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0001 0001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0001 0010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0001 0011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0001 0100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0001 0101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0001 0110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0001 0111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0001 1000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0001 1001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0001 1010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0001 1011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0001 1100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0001 1101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0001 1110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0001 1111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0010 0000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0010 0001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0010 0010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0010 0011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0010 0100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0010 0101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0010 0110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0010 0111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0010 1000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0010 1001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0010 1010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0010 1011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0010 1100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0010 1101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0010 1110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0010 1111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0011 0000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0011 0001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0011 0010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0011 0011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0011 0100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0011 0101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0011 0110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0011 0111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0011 1000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0011 1001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0011 1010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0011 1011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0011 1100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0011 1101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0011 1110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0011 1111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0100 0000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0100 0001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0100 0010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0100 0011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0100 0100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0100 0101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0100 0110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0100 0111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0100 1000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0100 1001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0100 1010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0100 1011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0100 1100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0100 1101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0100 1110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0100 1111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0101 0000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0101 0001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0101 0010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0101 0011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0101 0100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0101 0101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0101 0110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0101 0111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0101 1000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0101 1001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0101 1010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0101 1011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0101 1100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0101 1101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0101 1110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0101 1111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0110 0000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0110 0001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0110 0010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0110 0011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0110 0100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0110 0101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0110 0110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0110 0111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0110 1000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0110 1001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0110 1010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0110 1011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0110 1100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0110 1101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0110 1110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0110 1111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0111 0000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0111 0001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0111 0010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0111 0011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0111 0100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0111 0101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0111 0110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0111 0111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0111 1000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0111 1001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0111 1010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0111 1011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0111 1100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0111 1101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0111 1110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 0111 1111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1000 0000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1000 0001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1000 0010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1000 0011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1000 0100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1000 0101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1000 0110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1000 0111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1000 1000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1000 1001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1000 1010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1000 1011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1000 1100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1000 1101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1000 1110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1000 1111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1001 0000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1001 0001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1001 0010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1001 0011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1001 0100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1001 0101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1001 0110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1001 0111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1001 1000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1001 1001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1001 1010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1001 1011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1001 1100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1001 1101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1001 1110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1001 1111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1010 0000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1010 0001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1010 0010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1010 0011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1010 0100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1010 0101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1010 0110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1010 0111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1010 1000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1010 1001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1010 1010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1010 1011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1010 1100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1010 1101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1010 1110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1010 1111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1011 0000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1011 0001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1011 0010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1011 0011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1011 0100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1011 0101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1011 0110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1011 0111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1011 1000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1011 1001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1011 1010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1011 1011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1011 1100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1011 1101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1011 1110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1011 1111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1100 0000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1100 0001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1100 0010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1100 0011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1100 0100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1100 0101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1100 0110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1100 0111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1100 1000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1100 1001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1100 1010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1100 1011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1100 1100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1100 1101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1100 1110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1100 1111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1101 0000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1101 0001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1101 0010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1101 0011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1101 0100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1101 0101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1101 0110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1101 0111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1101 1000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1101 1001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1101 1010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1101 1011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1101 1100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1101 1101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1101 1110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1101 1111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1110 0000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1110 0001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1110 0010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1110 0011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1110 0100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1110 0101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1110 0110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1110 0111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1110 1000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1110 1001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1110 1010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1110 1011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1110 1100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1110 1101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1110 1110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1110 1111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1111 0000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1111 0001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1111 0010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1111 0011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1111 0100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1111 0101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1111 0110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1111 0111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1111 1000 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1111 1001 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1111 1010 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1111 1011 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1111 1100 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1111 1101 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1111 1110 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,

    // 1111 1111 1111 0000
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000,
    OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000, OP_GLUE_F000
};
